#include "sbpdfutils.h"

zend_class_entry *TElPDFPermissions_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFPermissions, Load)
{
	long l4Revision;
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Value, &l4Revision) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_Load(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value, (int32_t)l4Revision) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, Save)
{
	long l4Revision;
	zend_bool bPubKeyHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Revision, &bPubKeyHandler) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPDFPermissions_Save(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Revision, (int8_t)bPubKeyHandler, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, DisableAll)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_DisableAll(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, EnableAll)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_EnableAll(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_Modify)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_Modify(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_Modify)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_Modify(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_Extract)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_Extract)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_Annotations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_Annotations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_Annotations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_Annotations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_FillInForms)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_FillInForms(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_FillInForms)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_FillInForms(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_ExtractAcc)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_ExtractAcc(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_ExtractAcc)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_ExtractAcc(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_Assemble)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_Assemble(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_Assemble)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_Assemble(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_LowQualityPrint)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_LowQualityPrint(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_LowQualityPrint)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_LowQualityPrint(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, get_HighQualityPrint)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFPermissions_get_HighQualityPrint(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, set_HighQualityPrint)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFPermissions_set_HighQualityPrint(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFPermissions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFPermissions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_Load, 0, 0, 2)
	ZEND_ARG_INFO(0, Value)
	ZEND_ARG_INFO(0, Revision)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_Save, 0, 0, 2)
	ZEND_ARG_INFO(0, Revision)
	ZEND_ARG_INFO(0, PubKeyHandler)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_DisableAll, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_EnableAll, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_Modify, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_Modify, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_Extract, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_Extract, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_Annotations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_Annotations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_FillInForms, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_FillInForms, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_ExtractAcc, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_ExtractAcc, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_Assemble, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_Assemble, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_LowQualityPrint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_LowQualityPrint, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_get_HighQualityPrint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions_set_HighQualityPrint, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFPermissions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFPermissions_methods[] = {
	PHP_ME(TElPDFPermissions, Load, arginfo_TElPDFPermissions_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, Save, arginfo_TElPDFPermissions_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, DisableAll, arginfo_TElPDFPermissions_DisableAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, EnableAll, arginfo_TElPDFPermissions_EnableAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_Modify, arginfo_TElPDFPermissions_get_Modify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_Modify, arginfo_TElPDFPermissions_set_Modify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_Extract, arginfo_TElPDFPermissions_get_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_Extract, arginfo_TElPDFPermissions_set_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_Annotations, arginfo_TElPDFPermissions_get_Annotations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_Annotations, arginfo_TElPDFPermissions_set_Annotations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_FillInForms, arginfo_TElPDFPermissions_get_FillInForms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_FillInForms, arginfo_TElPDFPermissions_set_FillInForms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_ExtractAcc, arginfo_TElPDFPermissions_get_ExtractAcc, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_ExtractAcc, arginfo_TElPDFPermissions_set_ExtractAcc, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_Assemble, arginfo_TElPDFPermissions_get_Assemble, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_Assemble, arginfo_TElPDFPermissions_set_Assemble, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_LowQualityPrint, arginfo_TElPDFPermissions_get_LowQualityPrint, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_LowQualityPrint, arginfo_TElPDFPermissions_set_LowQualityPrint, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, get_HighQualityPrint, arginfo_TElPDFPermissions_get_HighQualityPrint, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, set_HighQualityPrint, arginfo_TElPDFPermissions_set_HighQualityPrint, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFPermissions, __construct, arginfo_TElPDFPermissions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFPermissions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFPermissions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFPermissions", TElPDFPermissions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFPermissions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPDFUtils, IntToByteArray)
{
	long l4Value;
	uint32_t _err;
	zend_bool bLittleEndian;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Value, &bLittleEndian) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPDFUtils_IntToByteArray((int32_t)l4Value, (int8_t)bLittleEndian, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(244735852, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFUtils, UIntToByteArray)
{
	long u4Value;
	uint32_t _err;
	zend_bool bLittleEndian;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u4Value, &bLittleEndian) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPDFUtils_UIntToByteArray((uint32_t)u4Value, (int8_t)bLittleEndian, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1288734326, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFUtils, IsPNGPredictor)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPDFUtils_IsPNGPredictor((int32_t)l4Value, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFUtils, DecodePNG)
{
	long l4Cols;
	long l4Count;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaBuffer, &l4StartIndex, &l4Count, &l4Cols) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBPDFUtils_DecodePNG(aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count, (int32_t)l4Cols, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(46507165, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFUtils, TrimArray)
{
	SBArrayZValInfo aia;
	uint32_t _err;
	zval *zaa;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaa) == SUCCESS) && PZVAL_IS_REF(zaa) && ((IS_STRING == Z_TYPE_P(zaa)) || (IS_ARRAY == Z_TYPE_P(zaa))))
	{
		if (!SBGetByteArrayFromZVal(zaa, &aia TSRMLS_CC)) RETURN_FALSE;
		_err = SBPDFUtils_TrimArray(aia.data, &aia.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaa, &aia TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1318495411, 0, aia.data, &aia.len) TSRMLS_CC);
			((char *)aia.data)[aia.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aia);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aia, zaa);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string)" TSRMLS_CC);
	}
}

void Register_SBPDFUtils_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPDFUtils, PREDICTOR_NONE, SB_PREDICTOR_NONE, SB_PREDICTOR_NONE);
	SB_REGISTER_LONG_CONSTANT(SBPDFUtils, PREDICTOR_PNG_UP, SB_PREDICTOR_PNG_UP, SB_PREDICTOR_PNG_UP);
}

void Register_SBPDFUtils_Aliases(TSRMLS_D)
{
	if (NULL == TElPDFPermissions_ce_ptr)
		Register_TElPDFPermissions(TSRMLS_C);
	zend_register_class_alias("ElPDFPermissions", TElPDFPermissions_ce_ptr);
}

