#include "sbtypes.h"

zend_class_entry *TSBHostRole_ce_ptr = NULL;

#ifndef SB_WINDOWS
SB_PHP_METHOD(_FILETIME, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_FILETIME));
		intern->len = sizeof(_FILETIME);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_FILETIME, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_FILETIME));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(_FILETIME, get_dwLowDateTime)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_FILETIME, set_dwLowDateTime)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(_FILETIME, get_dwHighDateTime)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(_FILETIME, set_dwHighDateTime)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *_FILETIME_ce_ptr = NULL;

static zend_function_entry _FILETIME_methods[] = {
	PHP_ME(_FILETIME, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_FILETIME, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(_FILETIME, get_dwLowDateTime, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_FILETIME, set_dwLowDateTime, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(_FILETIME, get_dwHighDateTime, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(_FILETIME, set_dwHighDateTime, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register__FILETIME(TSRMLS_D)
{
	zend_class_entry ce;
	if (_FILETIME_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_FILETIME", _FILETIME_methods);
	_FILETIME_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_LARGE_INTEGER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_LARGE_INTEGER));
		intern->len = sizeof(_LARGE_INTEGER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_LARGE_INTEGER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_LARGE_INTEGER));
}

zend_class_entry *_LARGE_INTEGER_ce_ptr = NULL;

static zend_function_entry _LARGE_INTEGER_methods[] = {
	PHP_ME(_LARGE_INTEGER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_LARGE_INTEGER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register__LARGE_INTEGER(TSRMLS_D)
{
	zend_class_entry ce;
	if (_LARGE_INTEGER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_LARGE_INTEGER", _LARGE_INTEGER_methods);
	_LARGE_INTEGER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(_ULARGE_INTEGER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(_ULARGE_INTEGER));
		intern->len = sizeof(_ULARGE_INTEGER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(_ULARGE_INTEGER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(_ULARGE_INTEGER));
}

zend_class_entry *_ULARGE_INTEGER_ce_ptr = NULL;

static zend_function_entry _ULARGE_INTEGER_methods[] = {
	PHP_ME(_ULARGE_INTEGER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(_ULARGE_INTEGER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register__ULARGE_INTEGER(TSRMLS_D)
{
	zend_class_entry ce;
	if (_ULARGE_INTEGER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "_ULARGE_INTEGER", _ULARGE_INTEGER_methods);
	_ULARGE_INTEGER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}
#endif

zend_class_entry *TSBFileTransferMode_ce_ptr = NULL;

zend_class_entry *TSBFileCopyMode_ce_ptr = NULL;

zend_class_entry *TSBParamQuoteMode_ce_ptr = NULL;

zend_class_entry *TSBEOLMarker_ce_ptr = NULL;

zend_class_entry *TSBCaseConversion_ce_ptr = NULL;

zend_class_entry *TSBOperationErrorHandling_ce_ptr = NULL;

SB_PHP_METHOD(TMessageDigest128, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest128));
		intern->len = sizeof(TMessageDigest128);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest128, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest128));
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()
#endif

SB_PHP_METHOD(TMessageDigest128, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest128, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest128, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest128, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest128, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest128, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest128, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest128, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *TMessageDigest128_ce_ptr = NULL;

static zend_function_entry TMessageDigest128_methods[] = {
	PHP_ME(TMessageDigest128, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest128, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest128, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest128(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest128_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest128", TMessageDigest128_methods);
	TMessageDigest128_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMessageDigest160, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest160));
		intern->len = sizeof(TMessageDigest160);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest160, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest160));
}

SB_PHP_METHOD(TMessageDigest160, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest160, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest160, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest160, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest160, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest160, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest160, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest160, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest160, get_E)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest160, set_E)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

zend_class_entry *TMessageDigest160_ce_ptr = NULL;

static zend_function_entry TMessageDigest160_methods[] = {
	PHP_ME(TMessageDigest160, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest160, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, get_E, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest160, set_E, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest160(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest160_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest160", TMessageDigest160_methods);
	TMessageDigest160_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMessageDigest224, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest224));
		intern->len = sizeof(TMessageDigest224);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest224, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest224));
}

SB_PHP_METHOD(TMessageDigest224, get_A1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest224, set_A1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest224, get_B1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest224, set_B1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest224, get_C1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest224, set_C1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest224, get_D1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest224, set_D1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest224, get_A2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest224, set_A2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest224, get_B2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TMessageDigest224, set_B2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TMessageDigest224, get_C2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest224, set_C2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

zend_class_entry *TMessageDigest224_ce_ptr = NULL;

static zend_function_entry TMessageDigest224_methods[] = {
	PHP_ME(TMessageDigest224, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest224, get_A1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_A1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, get_B1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_B1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, get_C1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_C1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, get_D1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_D1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, get_A2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_A2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, get_B2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_B2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, get_C2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest224, set_C2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest224(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest224_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest224", TMessageDigest224_methods);
	TMessageDigest224_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMessageDigest256, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest256));
		intern->len = sizeof(TMessageDigest256);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest256, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest256));
}

SB_PHP_METHOD(TMessageDigest256, get_A1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest256, set_A1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest256, get_B1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest256, set_B1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest256, get_C1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest256, set_C1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest256, get_D1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest256, set_D1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest256, get_A2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest256, set_A2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest256, get_B2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TMessageDigest256, set_B2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TMessageDigest256, get_C2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest256, set_C2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest256, get_D2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TMessageDigest256, set_D2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

zend_class_entry *TMessageDigest256_ce_ptr = NULL;

static zend_function_entry TMessageDigest256_methods[] = {
	PHP_ME(TMessageDigest256, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest256, get_A1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_A1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_B1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_B1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_C1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_C1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_D1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_D1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_A2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_A2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_B2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_B2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_C2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_C2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, get_D2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest256, set_D2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest256(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest256_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest256", TMessageDigest256_methods);
	TMessageDigest256_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMessageDigest320, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest320));
		intern->len = sizeof(TMessageDigest320);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest320, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest320));
}

SB_PHP_METHOD(TMessageDigest320, get_A1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest320, set_A1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest320, get_B1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest320, set_B1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TMessageDigest320, get_C1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest320, set_C1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest320, get_D1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest320, set_D1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TMessageDigest320, get_E1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest320, set_E1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest320, get_A2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TMessageDigest320, set_A2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(TMessageDigest320, get_B2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest320, set_B2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest320, get_C2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TMessageDigest320, set_C2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(TMessageDigest320, get_D2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TMessageDigest320, set_D2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TMessageDigest320, get_E2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(TMessageDigest320, set_E2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

zend_class_entry *TMessageDigest320_ce_ptr = NULL;

static zend_function_entry TMessageDigest320_methods[] = {
	PHP_ME(TMessageDigest320, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest320, get_A1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_A1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_B1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_B1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_C1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_C1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_D1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_D1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_E1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_E1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_A2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_A2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_B2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_B2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_C2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_C2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_D2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_D2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, get_E2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest320, set_E2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest320(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest320_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest320", TMessageDigest320_methods);
	TMessageDigest320_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMessageDigest384, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest384));
		intern->len = sizeof(TMessageDigest384);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest384, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest384));
}

SB_PHP_METHOD(TMessageDigest384, get_A)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest384, set_A)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest384, get_B)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest384, set_B)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest384, get_C)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest384, set_C)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest384, get_D)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest384, set_D)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest384, get_E)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TMessageDigest384, set_E)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TMessageDigest384, get_F)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TMessageDigest384, set_F)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

zend_class_entry *TMessageDigest384_ce_ptr = NULL;

static zend_function_entry TMessageDigest384_methods[] = {
	PHP_ME(TMessageDigest384, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest384, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, get_E, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, set_E, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, get_F, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest384, set_F, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest384(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest384_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest384", TMessageDigest384_methods);
	TMessageDigest384_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMessageDigest512, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMessageDigest512));
		intern->len = sizeof(TMessageDigest512);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMessageDigest512, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMessageDigest512));
}

SB_PHP_METHOD(TMessageDigest512, get_A1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest512, set_A1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TMessageDigest512, get_B1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest512, set_B1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TMessageDigest512, get_C1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest512, set_C1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(TMessageDigest512, get_D1)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest512, set_D1)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(TMessageDigest512, get_A2)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TMessageDigest512, set_A2)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(TMessageDigest512, get_B2)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TMessageDigest512, set_B2)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(TMessageDigest512, get_C2)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TMessageDigest512, set_C2)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(TMessageDigest512, get_D2)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(TMessageDigest512, set_D2)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

zend_class_entry *TMessageDigest512_ce_ptr = NULL;

static zend_function_entry TMessageDigest512_methods[] = {
	PHP_ME(TMessageDigest512, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMessageDigest512, get_A1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_A1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_B1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_B1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_C1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_C1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_D1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_D1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_A2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_A2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_B2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_B2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_C2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_C2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, get_D2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMessageDigest512, set_D2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMessageDigest512(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMessageDigest512_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMessageDigest512", TMessageDigest512_methods);
	TMessageDigest512_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBUInt32Pair, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBUInt32Pair));
		intern->len = sizeof(TSBUInt32Pair);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBUInt32Pair, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBUInt32Pair));
}

SB_PHP_METHOD(TSBUInt32Pair, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBUInt32Pair, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBUInt32Pair, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBUInt32Pair, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *TSBUInt32Pair_ce_ptr = NULL;

static zend_function_entry TSBUInt32Pair_methods[] = {
	PHP_ME(TSBUInt32Pair, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32Pair, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBUInt32Pair, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32Pair, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32Pair, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32Pair, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBUInt32Pair(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBUInt32Pair_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBUInt32Pair", TSBUInt32Pair_methods);
	TSBUInt32Pair_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *ConversionResult_ce_ptr = NULL;

zend_class_entry *ConversionFlags_ce_ptr = NULL;

zend_class_entry *TElStringHolder_ce_ptr = NULL;

SB_PHP_METHOD(TElStringHolder, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElStringHolder_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1291958001, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringHolder, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElStringHolder_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringHolder, __construct)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStringHolder_Create(sData, (int32_t)sData_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringHolder_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringHolder_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringHolder___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

static zend_function_entry TElStringHolder_methods[] = {
	PHP_ME(TElStringHolder, get_Value, arginfo_TElStringHolder_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringHolder, set_Value, arginfo_TElStringHolder_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringHolder, __construct, arginfo_TElStringHolder___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElStringHolder(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElStringHolder_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElStringHolder", TElStringHolder_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElStringHolder_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElByteArrayHolder_ce_ptr = NULL;

SB_PHP_METHOD(TElByteArrayHolder, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElByteArrayHolder_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(725365203, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayHolder, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElByteArrayHolder_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayHolder, __construct)
{
	SBArrayZValInfo aiData;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElByteArrayHolder_Create(aiData.data, aiData.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayHolder_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayHolder_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayHolder___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElByteArrayHolder_methods[] = {
	PHP_ME(TElByteArrayHolder, get_Value, arginfo_TElByteArrayHolder_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayHolder, set_Value, arginfo_TElByteArrayHolder_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayHolder, __construct, arginfo_TElByteArrayHolder___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElByteArrayHolder(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElByteArrayHolder_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElByteArrayHolder", TElByteArrayHolder_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElByteArrayHolder_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBTypes_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBTypes, MaxArrSize, SB_MaxArrSize, SB_MaxArrSize);
}

void Register_SBTypes_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBHostRole", NULL);
	TSBHostRole_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBHostRole_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBHostRole_ce_ptr, "hrNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBHostRole_ce_ptr, "hrServer", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBHostRole_ce_ptr, "hrClient", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBHostRole_ce_ptr, "hrBoth", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBFileTransferMode", NULL);
	TSBFileTransferMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFileTransferMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmOverwrite", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmSkip", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmAppendToEnd", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmResume", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmOverwriteIfDiffSize", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmSaveWithNewName", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileTransferMode_ce_ptr, "ftmRenameExistingTarget", 6)
	
	INIT_CLASS_ENTRY(ce, "TSBFileCopyMode", NULL);
	TSBFileCopyMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFileCopyMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFileCopyMode_ce_ptr, "fcmCopy", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileCopyMode_ce_ptr, "fcmCopyAndDeleteImmediate", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFileCopyMode_ce_ptr, "fcmCopyAndDeleteOnCompletion", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBParamQuoteMode", NULL);
	TSBParamQuoteMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBParamQuoteMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBParamQuoteMode_ce_ptr, "pqmNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBParamQuoteMode_ce_ptr, "pqmWithSpace", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBParamQuoteMode_ce_ptr, "pqmAll", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBEOLMarker", NULL);
	TSBEOLMarker_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBEOLMarker_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBEOLMarker_ce_ptr, "emCRLF", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBEOLMarker_ce_ptr, "emCR", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBEOLMarker_ce_ptr, "emLF", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBEOLMarker_ce_ptr, "emNone", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBCaseConversion", NULL);
	TSBCaseConversion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCaseConversion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCaseConversion_ce_ptr, "sccNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCaseConversion_ce_ptr, "sccLower", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCaseConversion_ce_ptr, "sccUpper", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBOperationErrorHandling", NULL);
	TSBOperationErrorHandling_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOperationErrorHandling_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOperationErrorHandling_ce_ptr, "oehTryAllItems", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOperationErrorHandling_ce_ptr, "oehStopOnFailure", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBOperationErrorHandling_ce_ptr, "oehIgnoreErrors", 2)
	
	INIT_CLASS_ENTRY(ce, "ConversionResult", NULL);
	ConversionResult_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	ConversionResult_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(ConversionResult_ce_ptr, "conversionOK", 0)
	SB_DECLARE_CLASS_LONG_CONST(ConversionResult_ce_ptr, "sourceExhausted", 1)
	SB_DECLARE_CLASS_LONG_CONST(ConversionResult_ce_ptr, "targetExhausted", 2)
	SB_DECLARE_CLASS_LONG_CONST(ConversionResult_ce_ptr, "sourceIllegal", 3)
	
	INIT_CLASS_ENTRY(ce, "ConversionFlags", NULL);
	ConversionFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	ConversionFlags_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(ConversionFlags_ce_ptr, "strictConversion", 0)
	SB_DECLARE_CLASS_LONG_CONST(ConversionFlags_ce_ptr, "lenientConversion", 1)
}

void Register_SBTypes_Aliases(TSRMLS_D)
{
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	zend_register_class_alias("TElInputStream", TStream_ce_ptr);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	zend_register_class_alias("TElOutputStream", TStream_ce_ptr);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	zend_register_class_alias("TSBObject", TObject_ce_ptr);
#ifndef SB_WINDOWS
	if (NULL == _FILETIME_ce_ptr)
		Register__FILETIME(TSRMLS_C);
	zend_register_class_alias("SBTypes_FILETIME", _FILETIME_ce_ptr);
	if (NULL == _FILETIME_ce_ptr)
		Register__FILETIME(TSRMLS_C);
	zend_register_class_alias("TFileTime", _FILETIME_ce_ptr);
	if (NULL == _LARGE_INTEGER_ce_ptr)
		Register__LARGE_INTEGER(TSRMLS_C);
	zend_register_class_alias("SBTypes_LARGE_INTEGER", _LARGE_INTEGER_ce_ptr);
	if (NULL == _ULARGE_INTEGER_ce_ptr)
		Register__ULARGE_INTEGER(TSRMLS_C);
	zend_register_class_alias("ULARGE_INTEGER", _ULARGE_INTEGER_ce_ptr);
#endif
}
