#include "sbdefs.h"
#ifdef SB_WINDOWS
#include "sbzipsfxmaker.h"

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY));
		intern->len = sizeof(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, get_VirtualAddress)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, set_VirtualAddress)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, get_Size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, set_Size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_methods[] = {
	PHP_ME(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, get_VirtualAddress, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, set_VirtualAddress, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DATA_DIRECTORY, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker__IMAGE_DATA_DIRECTORY(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker__IMAGE_DATA_DIRECTORY", SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_methods);
	SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER));
		intern->len = sizeof(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER));
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_Magic)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_Magic)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorLinkerVersion)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorLinkerVersion)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorLinkerVersion)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorLinkerVersion)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfCode)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfCode)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfInitializedData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfInitializedData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfUninitializedData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfUninitializedData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_AddressOfEntryPoint)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_AddressOfEntryPoint)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_BaseOfCode)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_BaseOfCode)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_BaseOfData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_BaseOfData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_ImageBase)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_ImageBase)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SectionAlignment)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SectionAlignment)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_FileAlignment)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_FileAlignment)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorOperatingSystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorOperatingSystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorOperatingSystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 42);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorOperatingSystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 42);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorImageVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorImageVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorImageVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 46);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorImageVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 46);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorSubsystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorSubsystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorSubsystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 50);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorSubsystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 50);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_Win32VersionValue)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_Win32VersionValue)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfImage)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfImage)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfHeaders)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfHeaders)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_CheckSum)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_CheckSum)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_Subsystem)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_Subsystem)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_DllCharacteristics)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 70);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_DllCharacteristics)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 70);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfStackReserve)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfStackReserve)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfStackCommit)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfStackCommit)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapReserve)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapReserve)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapCommit)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapCommit)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_LoaderFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_LoaderFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_NumberOfRvaAndSizes)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_NumberOfRvaAndSizes)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

zend_class_entry *SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_methods[] = {
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_Magic, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_Magic, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorLinkerVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorLinkerVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorLinkerVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorLinkerVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfCode, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfCode, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfInitializedData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfInitializedData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfUninitializedData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfUninitializedData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_AddressOfEntryPoint, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_AddressOfEntryPoint, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_BaseOfCode, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_BaseOfCode, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_BaseOfData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_BaseOfData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_ImageBase, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_ImageBase, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SectionAlignment, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SectionAlignment, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_FileAlignment, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_FileAlignment, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorOperatingSystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorOperatingSystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorOperatingSystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorOperatingSystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorImageVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorImageVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorImageVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorImageVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MajorSubsystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MajorSubsystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_MinorSubsystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_MinorSubsystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_Win32VersionValue, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_Win32VersionValue, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfImage, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfImage, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfHeaders, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfHeaders, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_CheckSum, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_CheckSum, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_Subsystem, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_Subsystem, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_DllCharacteristics, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_DllCharacteristics, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfStackReserve, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfStackReserve, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfStackCommit, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfStackCommit, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapReserve, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapReserve, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapCommit, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapCommit, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_LoaderFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_LoaderFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, get_NumberOfRvaAndSizes, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER, set_NumberOfRvaAndSizes, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER", SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_methods);
	SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker__IMAGE_DOS_HEADER));
		intern->len = sizeof(SBZIPSFXMaker__IMAGE_DOS_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker__IMAGE_DOS_HEADER));
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_magic)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_magic)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cblp)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cblp)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cp)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cp)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_crlc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_crlc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cparhdr)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cparhdr)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_minalloc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 10);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_minalloc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 10);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_maxalloc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_maxalloc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_ss)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_ss)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_sp)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_sp)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_csum)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_csum)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_ip)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_ip)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cs)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 22);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cs)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 22);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_lfarlc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_lfarlc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_ovno)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 26);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_ovno)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 26);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_oemid)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_oemid)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_oeminfo)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 38);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_oeminfo)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 38);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, get__lfanew)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_DOS_HEADER, set__lfanew)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

zend_class_entry *SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker__IMAGE_DOS_HEADER_methods[] = {
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_magic, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_magic, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cblp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cblp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_crlc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_crlc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cparhdr, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cparhdr, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_minalloc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_minalloc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_maxalloc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_maxalloc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_ss, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_ss, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_sp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_sp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_csum, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_csum, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_ip, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_ip, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_cs, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_cs, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_lfarlc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_lfarlc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_ovno, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_ovno, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_oemid, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_oemid, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get_e_oeminfo, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set_e_oeminfo, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, get__lfanew, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_DOS_HEADER, set__lfanew, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker__IMAGE_DOS_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker__IMAGE_DOS_HEADER", SBZIPSFXMaker__IMAGE_DOS_HEADER_methods);
	SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker__IMAGE_FILE_HEADER));
		intern->len = sizeof(SBZIPSFXMaker__IMAGE_FILE_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker__IMAGE_FILE_HEADER));
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_Machine)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_Machine)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_NumberOfSections)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_NumberOfSections)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_TimeDateStamp)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_TimeDateStamp)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_PointerToSymbolTable)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_PointerToSymbolTable)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_NumberOfSymbols)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_NumberOfSymbols)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_SizeOfOptionalHeader)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_SizeOfOptionalHeader)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_Characteristics)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_Characteristics)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

zend_class_entry *SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker__IMAGE_FILE_HEADER_methods[] = {
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_Machine, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_Machine, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_NumberOfSections, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_NumberOfSections, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_TimeDateStamp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_TimeDateStamp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_PointerToSymbolTable, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_PointerToSymbolTable, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_NumberOfSymbols, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_NumberOfSymbols, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_SizeOfOptionalHeader, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_SizeOfOptionalHeader, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, get_Characteristics, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_FILE_HEADER, set_Characteristics, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker__IMAGE_FILE_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker__IMAGE_FILE_HEADER", SBZIPSFXMaker__IMAGE_FILE_HEADER_methods);
	SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_NT_HEADERS, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker__IMAGE_NT_HEADERS));
		intern->len = sizeof(SBZIPSFXMaker__IMAGE_NT_HEADERS);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_NT_HEADERS, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker__IMAGE_NT_HEADERS));
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_NT_HEADERS, get_Signature)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_NT_HEADERS, set_Signature)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker__IMAGE_NT_HEADERS_methods[] = {
	PHP_ME(SBZIPSFXMaker__IMAGE_NT_HEADERS, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_NT_HEADERS, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_NT_HEADERS, get_Signature, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_NT_HEADERS, set_Signature, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker__IMAGE_NT_HEADERS(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker__IMAGE_NT_HEADERS", SBZIPSFXMaker__IMAGE_NT_HEADERS_methods);
	SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBZIPSFXMaker_TISHMisc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker_TISHMisc));
		intern->len = sizeof(SBZIPSFXMaker_TISHMisc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker_TISHMisc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker_TISHMisc));
}

zend_class_entry *SBZIPSFXMaker_TISHMisc_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker_TISHMisc_methods[] = {
	PHP_ME(SBZIPSFXMaker_TISHMisc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker_TISHMisc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker_TISHMisc(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker_TISHMisc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker_TISHMisc", SBZIPSFXMaker_TISHMisc_methods);
	SBZIPSFXMaker_TISHMisc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBZIPSFXMaker__IMAGE_SECTION_HEADER));
		intern->len = sizeof(SBZIPSFXMaker__IMAGE_SECTION_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBZIPSFXMaker__IMAGE_SECTION_HEADER));
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_VirtualAddress)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_VirtualAddress)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_SizeOfRawData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_SizeOfRawData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_PointerToRawData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_PointerToRawData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_PointerToRelocations)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_PointerToRelocations)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_PointerToLinenumbers)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_PointerToLinenumbers)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_NumberOfRelocations)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_NumberOfRelocations)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_NumberOfLinenumbers)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_NumberOfLinenumbers)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_Characteristics)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_Characteristics)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

zend_class_entry *SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr = NULL;

static zend_function_entry SBZIPSFXMaker__IMAGE_SECTION_HEADER_methods[] = {
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_VirtualAddress, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_VirtualAddress, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_SizeOfRawData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_SizeOfRawData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_PointerToRawData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_PointerToRawData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_PointerToRelocations, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_PointerToRelocations, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_PointerToLinenumbers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_PointerToLinenumbers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_NumberOfRelocations, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_NumberOfRelocations, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_NumberOfLinenumbers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_NumberOfLinenumbers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, get_Characteristics, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBZIPSFXMaker__IMAGE_SECTION_HEADER, set_Characteristics, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBZIPSFXMaker__IMAGE_SECTION_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBZIPSFXMaker__IMAGE_SECTION_HEADER", SBZIPSFXMaker__IMAGE_SECTION_HEADER_methods);
	SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZIPSFXMaker_ce_ptr = NULL;

SB_PHP_METHOD(TElZIPSFXMaker, Execute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElZIPSFXMaker_Execute(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, get_Copyright)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElZIPSFXMaker_get_Copyright(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-722722857, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, set_Copyright)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElZIPSFXMaker_set_Copyright(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, get_Title)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElZIPSFXMaker_get_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1640740100, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, set_Title)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElZIPSFXMaker_set_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElZIPSFXMaker_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElZIPSFXMaker_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElZIPSFXMaker, __construct)
{
	zval *oAOutput;
	zval *oAStub;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oAStub, TStream_ce_ptr, &oAOutput, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZIPSFXMaker_Create(SBGetObjectHandle(oAStub TSRMLS_CC), SBGetObjectHandle(oAOutput TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_Execute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_get_Copyright, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_set_Copyright, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_get_Title, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_set_Title, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZIPSFXMaker___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, AStub, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, AOutput, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElZIPSFXMaker_methods[] = {
	PHP_ME(TElZIPSFXMaker, Execute, arginfo_TElZIPSFXMaker_Execute, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, get_Copyright, arginfo_TElZIPSFXMaker_get_Copyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, set_Copyright, arginfo_TElZIPSFXMaker_set_Copyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, get_Title, arginfo_TElZIPSFXMaker_get_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, set_Title, arginfo_TElZIPSFXMaker_set_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, get_OnProgress, arginfo_TElZIPSFXMaker_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, set_OnProgress, arginfo_TElZIPSFXMaker_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElZIPSFXMaker, __construct, arginfo_TElZIPSFXMaker___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZIPSFXMaker(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZIPSFXMaker_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZIPSFXMaker", TElZIPSFXMaker_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElZIPSFXMaker_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBZIPSFXMaker_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SIZEOF_SHORT_NAME, SB_IMAGE_SIZEOF_SHORT_NAME, SB_IMAGE_SIZEOF_SHORT_NAME);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_NUMBEROF_DIRECTORY_ENTRIES, SB_IMAGE_NUMBEROF_DIRECTORY_ENTRIES, SB_IMAGE_NUMBEROF_DIRECTORY_ENTRIES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SIZEOF_FILE_HEADER, SB_IMAGE_SIZEOF_FILE_HEADER, SB_IMAGE_SIZEOF_FILE_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_RELOCS_STRIPPED, SB_IMAGE_FILE_RELOCS_STRIPPED, SB_IMAGE_FILE_RELOCS_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_EXECUTABLE_IMAGE, SB_IMAGE_FILE_EXECUTABLE_IMAGE, SB_IMAGE_FILE_EXECUTABLE_IMAGE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_LINE_NUMS_STRIPPED, SB_IMAGE_FILE_LINE_NUMS_STRIPPED, SB_IMAGE_FILE_LINE_NUMS_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_LOCAL_SYMS_STRIPPED, SB_IMAGE_FILE_LOCAL_SYMS_STRIPPED, SB_IMAGE_FILE_LOCAL_SYMS_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_AGGRESIVE_WS_TRIM, SB_IMAGE_FILE_AGGRESIVE_WS_TRIM, SB_IMAGE_FILE_AGGRESIVE_WS_TRIM);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_BYTES_REVERSED_LO, SB_IMAGE_FILE_BYTES_REVERSED_LO, SB_IMAGE_FILE_BYTES_REVERSED_LO);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_32BIT_MACHINE, SB_IMAGE_FILE_32BIT_MACHINE, SB_IMAGE_FILE_32BIT_MACHINE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_DEBUG_STRIPPED, SB_IMAGE_FILE_DEBUG_STRIPPED, SB_IMAGE_FILE_DEBUG_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP, SB_IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP, SB_IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_NET_RUN_FROM_SWAP, SB_IMAGE_FILE_NET_RUN_FROM_SWAP, SB_IMAGE_FILE_NET_RUN_FROM_SWAP);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_SYSTEM, SB_IMAGE_FILE_SYSTEM, SB_IMAGE_FILE_SYSTEM);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_DLL, SB_IMAGE_FILE_DLL, SB_IMAGE_FILE_DLL);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_UP_SYSTEM_ONLY, SB_IMAGE_FILE_UP_SYSTEM_ONLY, SB_IMAGE_FILE_UP_SYSTEM_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_BYTES_REVERSED_HI, SB_IMAGE_FILE_BYTES_REVERSED_HI, SB_IMAGE_FILE_BYTES_REVERSED_HI);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_UNKNOWN, SB_IMAGE_FILE_MACHINE_UNKNOWN, SB_IMAGE_FILE_MACHINE_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_I386, SB_IMAGE_FILE_MACHINE_I386, SB_IMAGE_FILE_MACHINE_I386);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_R3000, SB_IMAGE_FILE_MACHINE_R3000, SB_IMAGE_FILE_MACHINE_R3000);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_R4000, SB_IMAGE_FILE_MACHINE_R4000, SB_IMAGE_FILE_MACHINE_R4000);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_R10000, SB_IMAGE_FILE_MACHINE_R10000, SB_IMAGE_FILE_MACHINE_R10000);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_ALPHA, SB_IMAGE_FILE_MACHINE_ALPHA, SB_IMAGE_FILE_MACHINE_ALPHA);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_FILE_MACHINE_POWERPC, SB_IMAGE_FILE_MACHINE_POWERPC, SB_IMAGE_FILE_MACHINE_POWERPC);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SIZEOF_SECTION_HEADER, SB_IMAGE_SIZEOF_SECTION_HEADER, SB_IMAGE_SIZEOF_SECTION_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_TYPE_NO_PAD, SB_IMAGE_SCN_TYPE_NO_PAD, SB_IMAGE_SCN_TYPE_NO_PAD);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_CNT_CODE, SB_IMAGE_SCN_CNT_CODE, SB_IMAGE_SCN_CNT_CODE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_CNT_INITIALIZED_DATA, SB_IMAGE_SCN_CNT_INITIALIZED_DATA, SB_IMAGE_SCN_CNT_INITIALIZED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_CNT_UNINITIALIZED_DATA, SB_IMAGE_SCN_CNT_UNINITIALIZED_DATA, SB_IMAGE_SCN_CNT_UNINITIALIZED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_LNK_OTHER, SB_IMAGE_SCN_LNK_OTHER, SB_IMAGE_SCN_LNK_OTHER);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_LNK_INFO, SB_IMAGE_SCN_LNK_INFO, SB_IMAGE_SCN_LNK_INFO);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_LNK_REMOVE, SB_IMAGE_SCN_LNK_REMOVE, SB_IMAGE_SCN_LNK_REMOVE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_LNK_COMDAT, SB_IMAGE_SCN_LNK_COMDAT, SB_IMAGE_SCN_LNK_COMDAT);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_FARDATA, SB_IMAGE_SCN_MEM_FARDATA, SB_IMAGE_SCN_MEM_FARDATA);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_PURGEABLE, SB_IMAGE_SCN_MEM_PURGEABLE, SB_IMAGE_SCN_MEM_PURGEABLE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_16BIT, SB_IMAGE_SCN_MEM_16BIT, SB_IMAGE_SCN_MEM_16BIT);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_LOCKED, SB_IMAGE_SCN_MEM_LOCKED, SB_IMAGE_SCN_MEM_LOCKED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_PRELOAD, SB_IMAGE_SCN_MEM_PRELOAD, SB_IMAGE_SCN_MEM_PRELOAD);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_1BYTES, SB_IMAGE_SCN_ALIGN_1BYTES, SB_IMAGE_SCN_ALIGN_1BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_2BYTES, SB_IMAGE_SCN_ALIGN_2BYTES, SB_IMAGE_SCN_ALIGN_2BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_4BYTES, SB_IMAGE_SCN_ALIGN_4BYTES, SB_IMAGE_SCN_ALIGN_4BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_8BYTES, SB_IMAGE_SCN_ALIGN_8BYTES, SB_IMAGE_SCN_ALIGN_8BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_16BYTES, SB_IMAGE_SCN_ALIGN_16BYTES, SB_IMAGE_SCN_ALIGN_16BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_32BYTES, SB_IMAGE_SCN_ALIGN_32BYTES, SB_IMAGE_SCN_ALIGN_32BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_ALIGN_64BYTES, SB_IMAGE_SCN_ALIGN_64BYTES, SB_IMAGE_SCN_ALIGN_64BYTES);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_LNK_NRELOC_OVFL, SB_IMAGE_SCN_LNK_NRELOC_OVFL, SB_IMAGE_SCN_LNK_NRELOC_OVFL);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_DISCARDABLE, SB_IMAGE_SCN_MEM_DISCARDABLE, SB_IMAGE_SCN_MEM_DISCARDABLE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_NOT_CACHED, SB_IMAGE_SCN_MEM_NOT_CACHED, SB_IMAGE_SCN_MEM_NOT_CACHED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_NOT_PAGED, SB_IMAGE_SCN_MEM_NOT_PAGED, SB_IMAGE_SCN_MEM_NOT_PAGED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_SHARED, SB_IMAGE_SCN_MEM_SHARED, SB_IMAGE_SCN_MEM_SHARED);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_EXECUTE, SB_IMAGE_SCN_MEM_EXECUTE, SB_IMAGE_SCN_MEM_EXECUTE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_READ, SB_IMAGE_SCN_MEM_READ, SB_IMAGE_SCN_MEM_READ);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SCN_MEM_WRITE, SB_IMAGE_SCN_MEM_WRITE, SB_IMAGE_SCN_MEM_WRITE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_NT_OPTIONAL_HDR_MAGIC, SB_IMAGE_NT_OPTIONAL_HDR_MAGIC, SB_IMAGE_NT_OPTIONAL_HDR_MAGIC);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SUBSYSTEM_WINDOWS_GUI, SB_IMAGE_SUBSYSTEM_WINDOWS_GUI, SB_IMAGE_SUBSYSTEM_WINDOWS_GUI);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, IMAGE_SUBSYSTEM_WINDOWS_CUI, SB_IMAGE_SUBSYSTEM_WINDOWS_CUI, SB_IMAGE_SUBSYSTEM_WINDOWS_CUI);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_ERROR_BASE, SB_ZIPSFX_ERROR_BASE, SB_ZIPSFX_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_OK, SB_ZIPSFX_OK, SB_ZIPSFX_OK);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_USER_ABORT, SB_ZIPSFX_USER_ABORT, SB_ZIPSFX_USER_ABORT);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INTERNAL_ERROR, SB_ZIPSFX_INTERNAL_ERROR, SB_ZIPSFX_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PARAMETER_TARGET, SB_ZIPSFX_INVALID_PARAMETER_TARGET, SB_ZIPSFX_INVALID_PARAMETER_TARGET);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PARAMETER_CERT, SB_ZIPSFX_INVALID_PARAMETER_CERT, SB_ZIPSFX_INVALID_PARAMETER_CERT);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PARAMETER_CERTPASS, SB_ZIPSFX_INVALID_PARAMETER_CERTPASS, SB_ZIPSFX_INVALID_PARAMETER_CERTPASS);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PARAMETER_PASS, SB_ZIPSFX_INVALID_PARAMETER_PASS, SB_ZIPSFX_INVALID_PARAMETER_PASS);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PARAMETER_EXTRACT, SB_ZIPSFX_INVALID_PARAMETER_EXTRACT, SB_ZIPSFX_INVALID_PARAMETER_EXTRACT);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_TARGET_FOLDER_FAILURE, SB_ZIPSFX_TARGET_FOLDER_FAILURE, SB_ZIPSFX_TARGET_FOLDER_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INPUT_STREAM_FAILURE, SB_ZIPSFX_INPUT_STREAM_FAILURE, SB_ZIPSFX_INPUT_STREAM_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_PACKET_FILE_ALREADY_EXISTS, SB_ZIPSFX_PACKET_FILE_ALREADY_EXISTS, SB_ZIPSFX_PACKET_FILE_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_PACKET_FILE_FAILURE, SB_ZIPSFX_PACKET_FILE_FAILURE, SB_ZIPSFX_PACKET_FILE_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_CERT_NOT_FOUND, SB_ZIPSFX_CERT_NOT_FOUND, SB_ZIPSFX_CERT_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_NO_CERT, SB_ZIPSFX_NO_CERT, SB_ZIPSFX_NO_CERT);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_METHOD, SB_ZIPSFX_INVALID_METHOD, SB_ZIPSFX_INVALID_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PASSWORD, SB_ZIPSFX_INVALID_PASSWORD, SB_ZIPSFX_INVALID_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_NO_ZIP_DATA, SB_ZIPSFX_NO_ZIP_DATA, SB_ZIPSFX_NO_ZIP_DATA);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_NO_SFX_DATA, SB_ZIPSFX_NO_SFX_DATA, SB_ZIPSFX_NO_SFX_DATA);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_MAKER_ERROR_BASE, SB_ZIPSFX_MAKER_ERROR_BASE, SB_ZIPSFX_MAKER_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_NO_STUB, SB_ZIPSFX_NO_STUB, SB_ZIPSFX_NO_STUB);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_DOS_SIGNATURE, SB_ZIPSFX_INVALID_DOS_SIGNATURE, SB_ZIPSFX_INVALID_DOS_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_PE_SIGNATURE, SB_ZIPSFX_INVALID_PE_SIGNATURE, SB_ZIPSFX_INVALID_PE_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_MACHINE_SPECIFIER, SB_ZIPSFX_INVALID_MACHINE_SPECIFIER, SB_ZIPSFX_INVALID_MACHINE_SPECIFIER);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_CHARACTERISTICS, SB_ZIPSFX_INVALID_CHARACTERISTICS, SB_ZIPSFX_INVALID_CHARACTERISTICS);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_OPTIONAL_SIGNATURE, SB_ZIPSFX_INVALID_OPTIONAL_SIGNATURE, SB_ZIPSFX_INVALID_OPTIONAL_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_INVALID_SUBSYSTEM, SB_ZIPSFX_INVALID_SUBSYSTEM, SB_ZIPSFX_INVALID_SUBSYSTEM);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_NO_SECTIONS, SB_ZIPSFX_NO_SECTIONS, SB_ZIPSFX_NO_SECTIONS);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_TITLE_TOO_LONG, SB_ZIPSFX_TITLE_TOO_LONG, SB_ZIPSFX_TITLE_TOO_LONG);
	SB_REGISTER_LONG_CONSTANT(SBZIPSFXMaker, SB_ZIPSFX_COPYRIGHT_TOO_LONG, SB_ZIPSFX_COPYRIGHT_TOO_LONG, SB_ZIPSFX_COPYRIGHT_TOO_LONG);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrNoStubStreamSpecified, SB_SErrNoStubStreamSpecified, SB_SErrNoStubStreamSpecified);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrInvalidDOSSignature, SB_SErrInvalidDOSSignature, SB_SErrInvalidDOSSignature);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrInvalidPESignature, SB_SErrInvalidPESignature, SB_SErrInvalidPESignature);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrInvalidMachineSpecifier, SB_SErrInvalidMachineSpecifier, SB_SErrInvalidMachineSpecifier);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrInvalidCharacteristics, SB_SErrInvalidCharacteristics, SB_SErrInvalidCharacteristics);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrInvalidOptionalSignature, SB_SErrInvalidOptionalSignature, SB_SErrInvalidOptionalSignature);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrInvalidSubsystem, SB_SErrInvalidSubsystem, SB_SErrInvalidSubsystem);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrNoSections, SB_SErrNoSections, SB_SErrNoSections);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrTitleTooLong, SB_SErrTitleTooLong, SB_SErrTitleTooLong);
	SB_REGISTER_STRING_CONSTANT(SBZIPSFXMaker, SErrCopyrightTooLong, SB_SErrCopyrightTooLong, SB_SErrCopyrightTooLong);
}

void Register_SBZIPSFXMaker_Aliases(TSRMLS_D)
{
	if (NULL == SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_DATA_DIRECTORY(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_TImageDataDirectory", SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_DATA_DIRECTORY(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_IMAGE_DATA_DIRECTORY", SBZIPSFXMaker__IMAGE_DATA_DIRECTORY_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_TImageOptionalHeader", SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_IMAGE_OPTIONAL_HEADER", SBZIPSFXMaker__IMAGE_OPTIONAL_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_DOS_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_TImageDosHeader", SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_DOS_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_IMAGE_DOS_HEADER", SBZIPSFXMaker__IMAGE_DOS_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_FILE_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_TImageFileHeader", SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_FILE_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_IMAGE_FILE_HEADER", SBZIPSFXMaker__IMAGE_FILE_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_NT_HEADERS(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_TImageNtHeaders", SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_NT_HEADERS(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_IMAGE_NT_HEADERS", SBZIPSFXMaker__IMAGE_NT_HEADERS_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_SECTION_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_TImageSectionHeader", SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr);
	if (NULL == SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr)
		Register_SBZIPSFXMaker__IMAGE_SECTION_HEADER(TSRMLS_C);
	zend_register_class_alias("SBZIPSFXMaker_IMAGE_SECTION_HEADER", SBZIPSFXMaker__IMAGE_SECTION_HEADER_ce_ptr);
}
#endif
