#include "sbasresources.h"

void Register_SBASResources_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorCannotOpenInputFile, SB_SASErrorCannotOpenInputFile, SB_SASErrorCannotOpenInputFile);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorCannotOpenOutputFile, SB_SASErrorCannotOpenOutputFile, SB_SASErrorCannotOpenOutputFile);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidEncryptionAlgorithm, SB_SASErrorInvalidEncryptionAlgorithm, SB_SASErrorInvalidEncryptionAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidSignatureDigestAlgorithm, SB_SASErrorInvalidSignatureDigestAlgorithm, SB_SASErrorInvalidSignatureDigestAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidBitsNumber, SB_SASErrorInvalidBitsNumber, SB_SASErrorInvalidBitsNumber);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorHeaderAssemblingFailed, SB_SASErrorHeaderAssemblingFailed, SB_SASErrorHeaderAssemblingFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorFileNotExists, SB_SASErrorFileNotExists, SB_SASErrorFileNotExists);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidSMIMEType, SB_SASErrorInvalidSMIMEType, SB_SASErrorInvalidSMIMEType);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidEncryptionTransferEncoding, SB_SASErrorInvalidEncryptionTransferEncoding, SB_SASErrorInvalidEncryptionTransferEncoding);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidCompressionTransferEncoding, SB_SASErrorInvalidCompressionTransferEncoding, SB_SASErrorInvalidCompressionTransferEncoding);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidEncryptionDisposition, SB_SASErrorInvalidEncryptionDisposition, SB_SASErrorInvalidEncryptionDisposition);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidContentType, SB_SASErrorInvalidContentType, SB_SASErrorInvalidContentType);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidContentDisposition, SB_SASErrorInvalidContentDisposition, SB_SASErrorInvalidContentDisposition);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidFileCreationDate, SB_SASErrorInvalidFileCreationDate, SB_SASErrorInvalidFileCreationDate);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidFileModificationDate, SB_SASErrorInvalidFileModificationDate, SB_SASErrorInvalidFileModificationDate);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidContentTransferEncoding, SB_SASErrorInvalidContentTransferEncoding, SB_SASErrorInvalidContentTransferEncoding);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReceiptSignatureProtocol, SB_SASErrorInvalidReceiptSignatureProtocol, SB_SASErrorInvalidReceiptSignatureProtocol);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReceiptSignatureProtocolRequirement, SB_SASErrorInvalidReceiptSignatureProtocolRequirement, SB_SASErrorInvalidReceiptSignatureProtocolRequirement);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReceiptDigestAlgorithm, SB_SASErrorInvalidReceiptDigestAlgorithm, SB_SASErrorInvalidReceiptDigestAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReceiptDigestAlgorithmRequirement, SB_SASErrorInvalidReceiptDigestAlgorithmRequirement, SB_SASErrorInvalidReceiptDigestAlgorithmRequirement);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidSignatureProtocol, SB_SASErrorInvalidSignatureProtocol, SB_SASErrorInvalidSignatureProtocol);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidSignatureMicAlg, SB_SASErrorInvalidSignatureMicAlg, SB_SASErrorInvalidSignatureMicAlg);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorDecryptionFailed, SB_SASErrorDecryptionFailed, SB_SASErrorDecryptionFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReportType, SB_SASErrorInvalidReportType, SB_SASErrorInvalidReportType);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidDispositionActionMode, SB_SASErrorInvalidDispositionActionMode, SB_SASErrorInvalidDispositionActionMode);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidDispositionSendingMode, SB_SASErrorInvalidDispositionSendingMode, SB_SASErrorInvalidDispositionSendingMode);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidDispositionStatus, SB_SASErrorInvalidDispositionStatus, SB_SASErrorInvalidDispositionStatus);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidDispositionModifier, SB_SASErrorInvalidDispositionModifier, SB_SASErrorInvalidDispositionModifier);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorDecompressionFailed, SB_SASErrorDecompressionFailed, SB_SASErrorDecompressionFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidCompressionDisposition, SB_SASErrorInvalidCompressionDisposition, SB_SASErrorInvalidCompressionDisposition);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS2ErrorInvalidOriginator, SB_SAS2ErrorInvalidOriginator, SB_SAS2ErrorInvalidOriginator);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS2ErrorInvalidRecipient, SB_SAS2ErrorInvalidRecipient, SB_SAS2ErrorInvalidRecipient);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS2ErrorInvalidVersion, SB_SAS2ErrorInvalidVersion, SB_SAS2ErrorInvalidVersion);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS3ErrorInvalidOriginator, SB_SAS3ErrorInvalidOriginator, SB_SAS3ErrorInvalidOriginator);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS3ErrorInvalidRecipient, SB_SAS3ErrorInvalidRecipient, SB_SAS3ErrorInvalidRecipient);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS3ErrorInvalidVersion, SB_SAS3ErrorInvalidVersion, SB_SAS3ErrorInvalidVersion);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReceiptTarget, SB_SASErrorNoReceiptTarget, SB_SASErrorNoReceiptTarget);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoEncryptingCertificates, SB_SASErrorNoEncryptingCertificates, SB_SASErrorNoEncryptingCertificates);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoSigningCertificates, SB_SASErrorNoSigningCertificates, SB_SASErrorNoSigningCertificates);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorSigningFailed, SB_SASErrorSigningFailed, SB_SASErrorSigningFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorVerificationFailed, SB_SASErrorVerificationFailed, SB_SASErrorVerificationFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorEncryptionFailed, SB_SASErrorEncryptionFailed, SB_SASErrorEncryptionFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInternal, SB_SASErrorInternal, SB_SASErrorInternal);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoOutputStream, SB_SASErrorNoOutputStream, SB_SASErrorNoOutputStream);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidMessageHeader, SB_SASErrorInvalidMessageHeader, SB_SASErrorInvalidMessageHeader);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidMessageHeaderCharset, SB_SASErrorInvalidMessageHeaderCharset, SB_SASErrorInvalidMessageHeaderCharset);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidMessageDate, SB_SASErrorInvalidMessageDate, SB_SASErrorInvalidMessageDate);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoVersion, SB_SASErrorNoVersion, SB_SASErrorNoVersion);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoMessageID, SB_SASErrorNoMessageID, SB_SASErrorNoMessageID);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoSMIMEType, SB_SASErrorNoSMIMEType, SB_SASErrorNoSMIMEType);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoEncryptionTransferEncoding, SB_SASErrorNoEncryptionTransferEncoding, SB_SASErrorNoEncryptionTransferEncoding);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoCompressionTransferEncoding, SB_SASErrorNoCompressionTransferEncoding, SB_SASErrorNoCompressionTransferEncoding);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoEncryptionDisposition, SB_SASErrorNoEncryptionDisposition, SB_SASErrorNoEncryptionDisposition);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoContentType, SB_SASErrorNoContentType, SB_SASErrorNoContentType);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoContentDisposition, SB_SASErrorNoContentDisposition, SB_SASErrorNoContentDisposition);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoFileName, SB_SASErrorNoFileName, SB_SASErrorNoFileName);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoFileCreationTime, SB_SASErrorNoFileCreationTime, SB_SASErrorNoFileCreationTime);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoFileModificationTime, SB_SASErrorNoFileModificationTime, SB_SASErrorNoFileModificationTime);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoContentTransferEncoding, SB_SASErrorNoContentTransferEncoding, SB_SASErrorNoContentTransferEncoding);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReceiptRequestOptions, SB_SASErrorInvalidReceiptRequestOptions, SB_SASErrorInvalidReceiptRequestOptions);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReceiptSignatureProtocol, SB_SASErrorNoReceiptSignatureProtocol, SB_SASErrorNoReceiptSignatureProtocol);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReceiptSignatureProtocolRequirement, SB_SASErrorNoReceiptSignatureProtocolRequirement, SB_SASErrorNoReceiptSignatureProtocolRequirement);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReceiptDigestAlgorithm, SB_SASErrorNoReceiptDigestAlgorithm, SB_SASErrorNoReceiptDigestAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReceiptDigestAlgorithmRequirement, SB_SASErrorNoReceiptDigestAlgorithmRequirement, SB_SASErrorNoReceiptDigestAlgorithmRequirement);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoSignatureProtocol, SB_SASErrorNoSignatureProtocol, SB_SASErrorNoSignatureProtocol);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoSignatureMicAlg, SB_SASErrorNoSignatureMicAlg, SB_SASErrorNoSignatureMicAlg);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoSignatureBoundary, SB_SASErrorNoSignatureBoundary, SB_SASErrorNoSignatureBoundary);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorErrorsAssemblingFailed, SB_SASErrorErrorsAssemblingFailed, SB_SASErrorErrorsAssemblingFailed);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReportBoundary, SB_SASErrorNoReportBoundary, SB_SASErrorNoReportBoundary);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidReportDispositionFormat, SB_SASErrorInvalidReportDispositionFormat, SB_SASErrorInvalidReportDispositionFormat);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS1ErrorEmptyOriginator, SB_SAS1ErrorEmptyOriginator, SB_SAS1ErrorEmptyOriginator);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS1ErrorEmptyRecipient, SB_SAS1ErrorEmptyRecipient, SB_SAS1ErrorEmptyRecipient);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS2ErrorEmptyOriginator, SB_SAS2ErrorEmptyOriginator, SB_SAS2ErrorEmptyOriginator);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS2ErrorEmptyRecipient, SB_SAS2ErrorEmptyRecipient, SB_SAS2ErrorEmptyRecipient);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS3ErrorEmptyOriginator, SB_SAS3ErrorEmptyOriginator, SB_SAS3ErrorEmptyOriginator);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SAS3ErrorEmptyRecipient, SB_SAS3ErrorEmptyRecipient, SB_SAS3ErrorEmptyRecipient);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidMessageCharset, SB_SASErrorInvalidMessageCharset, SB_SASErrorInvalidMessageCharset);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidMessageFormat, SB_SASErrorInvalidMessageFormat, SB_SASErrorInvalidMessageFormat);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoReportType, SB_SASErrorNoReportType, SB_SASErrorNoReportType);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorInvalidCompressionLevel, SB_SASErrorInvalidCompressionLevel, SB_SASErrorInvalidCompressionLevel);
	SB_REGISTER_STRING_CONSTANT(SBASResources, SASErrorNoCompressionDisposition, SB_SASErrorNoCompressionDisposition, SB_SASErrorNoCompressionDisposition);
}

