#include "sbchsconvbase.h"

zend_class_entry *IPlConvBuffer_ce_ptr = NULL;

zend_class_entry *IPlCharset_ce_ptr = NULL;

zend_class_entry *TPlCharsetClass_ce_ptr = NULL;

SB_PHP_METHOD(TPlHiBytes, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPlHiBytes));
		intern->len = sizeof(TPlHiBytes);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPlHiBytes, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPlHiBytes));
}

zend_class_entry *TPlHiBytes_ce_ptr = NULL;

static zend_function_entry TPlHiBytes_methods[] = {
	PHP_ME(TPlHiBytes, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPlHiBytes, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlHiBytes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlHiBytes_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPlHiBytes", TPlHiBytes_methods);
	TPlHiBytes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPlChars, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPlChars));
		intern->len = sizeof(TPlChars);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPlChars, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPlChars));
}

zend_class_entry *TPlChars_ce_ptr = NULL;

static zend_function_entry TPlChars_methods[] = {
	PHP_ME(TPlChars, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPlChars, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlChars(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlChars_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPlChars", TPlChars_methods);
	TPlChars_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPlConversionPage, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPlConversionPage));
		intern->len = sizeof(TPlConversionPage);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPlConversionPage, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPlConversionPage));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TPlConversionPage, get_CharsLoIndex)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TPlConversionPage, set_CharsLoIndex)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TPlConversionPage, get_CharsHiIndex)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 13);
}

SB_PHP_METHOD(TPlConversionPage, set_CharsHiIndex)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 13);
}

SB_PHP_METHOD(TPlConversionPage, get_PriorPageIndex)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(TPlConversionPage, set_PriorPageIndex)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(TPlConversionPage, get_PriorPageChar)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 15);
}

SB_PHP_METHOD(TPlConversionPage, set_PriorPageChar)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 15);
}

zend_class_entry *TPlConversionPage_ce_ptr = NULL;

static zend_function_entry TPlConversionPage_methods[] = {
	PHP_ME(TPlConversionPage, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlConversionPage, get_CharsLoIndex, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, set_CharsLoIndex, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, get_CharsHiIndex, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, set_CharsHiIndex, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, get_PriorPageIndex, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, set_PriorPageIndex, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, get_PriorPageChar, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPage, set_PriorPageChar, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlConversionPage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlConversionPage_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPlConversionPage", TPlConversionPage_methods);
	TPlConversionPage_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPlConversionPages, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPlConversionPages));
		intern->len = sizeof(TPlConversionPages);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPlConversionPages, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPlConversionPages));
}

zend_class_entry *TPlConversionPages_ce_ptr = NULL;

static zend_function_entry TPlConversionPages_methods[] = {
	PHP_ME(TPlConversionPages, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionPages, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlConversionPages(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlConversionPages_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPlConversionPages", TPlConversionPages_methods);
	TPlConversionPages_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPlUCSToMultiByteItem, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPlUCSToMultiByteItem));
		intern->len = sizeof(TPlUCSToMultiByteItem);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPlUCSToMultiByteItem, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPlUCSToMultiByteItem));
}

SB_PHP_METHOD(TPlUCSToMultiByteItem, get_Page)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TPlUCSToMultiByteItem, set_Page)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TPlUCSToMultiByteItem, get_Char)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TPlUCSToMultiByteItem, set_Char)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

zend_class_entry *TPlUCSToMultiByteItem_ce_ptr = NULL;

static zend_function_entry TPlUCSToMultiByteItem_methods[] = {
	PHP_ME(TPlUCSToMultiByteItem, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUCSToMultiByteItem, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlUCSToMultiByteItem, get_Page, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUCSToMultiByteItem, set_Page, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUCSToMultiByteItem, get_Char, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlUCSToMultiByteItem, set_Char, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlUCSToMultiByteItem(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlUCSToMultiByteItem_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPlUCSToMultiByteItem", TPlUCSToMultiByteItem_methods);
	TPlUCSToMultiByteItem_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPlConversionTable, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPlConversionTable));
		intern->len = sizeof(TPlConversionTable);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPlConversionTable, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPlConversionTable));
}

SB_PHP_METHOD(TPlConversionTable, get_MaxDirectMapped)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TPlConversionTable, set_MaxDirectMapped)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TPlConversionTable, get_PagesCount)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TPlConversionTable, set_PagesCount)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TPlConversionTable, get_BackItemsCount)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TPlConversionTable, set_BackItemsCount)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *TPlConversionTable_ce_ptr = NULL;

static zend_function_entry TPlConversionTable_methods[] = {
	PHP_ME(TPlConversionTable, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionTable, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlConversionTable, get_MaxDirectMapped, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionTable, set_MaxDirectMapped, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionTable, get_PagesCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionTable, set_PagesCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionTable, get_BackItemsCount, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConversionTable, set_BackItemsCount, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlConversionTable(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlConversionTable_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPlConversionTable", TPlConversionTable_methods);
	TPlConversionTable_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlCharset_ce_ptr = NULL;

SB_PHP_METHOD(TPlCharset, CanConvert)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TPlCharset_CanConvert(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlCharset_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlCharset_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlCharset_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, ConvertBufferToUTF16)
{
	int32_t l4DstCountRaw;
	long l4SrcCount;
	SBPointerZValInfo piDstBuf;
	SBPointerZValInfo piSrcBuf;
	zend_bool bIsLastChunk;
	zval *zl4DstCount;
	zval *zpDstBuf;
	zval *zpSrcBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbzz", &zpSrcBuf, &l4SrcCount, &bIsLastChunk, &zpDstBuf, &zl4DstCount) == SUCCESS) && ((Z_TYPE_P(zpSrcBuf) == IS_STRING) || (Z_TYPE_P(zpSrcBuf) == IS_ARRAY) || (Z_TYPE_P(zpSrcBuf) == IS_NULL) || ((Z_TYPE_P(zpSrcBuf) == IS_OBJECT) && (Z_OBJCE_P(zpSrcBuf) == TSBPointer_ce_ptr))) && ((PZVAL_IS_REF(zpDstBuf) && ((Z_TYPE_P(zpDstBuf) == IS_STRING) || (Z_TYPE_P(zpDstBuf) == IS_ARRAY))) || ((Z_TYPE_P(zpDstBuf) == IS_OBJECT) && (Z_OBJCE_P(zpDstBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DstCount) && (IS_LONG == Z_TYPE_P(zl4DstCount)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpSrcBuf, &piSrcBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpDstBuf, &piDstBuf TSRMLS_CC)) RETURN_FALSE;
		l4DstCountRaw = (int32_t)Z_LVAL_P(zl4DstCount);
		SBCheckError(TPlCharset_ConvertBufferToUTF16(SBGetObjectHandle(getThis() TSRMLS_CC), piSrcBuf.data, (int32_t)l4SrcCount, (int8_t)bIsLastChunk, piDstBuf.data, &l4DstCountRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piSrcBuf);
		SBSetPointerToZVal(&piDstBuf, zpDstBuf);
		ZVAL_LONG(zl4DstCount, (long)l4DstCountRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, TSBPointer|array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlCharset_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-989605709, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlCharset_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1234696671, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlCharset_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1804787472, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCharset_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCharset_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, CreateShift)
{
	long l4Shift;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Shift) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCharset_CreateShift((int32_t)l4Shift, &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, CreateNoInit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCharset_CreateNoInit(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlCharset, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlCharset_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_CanConvert, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_ConvertBufferToUTF16, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, SrcBuf, 0, 1)
	ZEND_ARG_INFO(0, SrcCount)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, DstBuf)
	ZEND_ARG_INFO(1, DstCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_CreateShift, 0, 0, 1)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_CreateNoInit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlCharset_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlCharset_methods[] = {
	PHP_ME(TPlCharset, CanConvert, arginfo_TPlCharset_CanConvert, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, ConvertFromUCS, arginfo_TPlCharset_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, ConvertToUCS, arginfo_TPlCharset_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, ConvertBufferToUCS, arginfo_TPlCharset_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, ConvertBufferToUTF16, arginfo_TPlCharset_ConvertBufferToUTF16, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, GetCategory, arginfo_TPlCharset_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, GetDescription, arginfo_TPlCharset_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, GetName, arginfo_TPlCharset_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, ClassType, arginfo_TPlCharset_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCharset, __construct, arginfo_TPlCharset___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlCharset, CreateShift, arginfo_TPlCharset_CreateShift, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCharset, CreateNoInit, arginfo_TPlCharset_CreateNoInit, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlCharset, CreateForFinalize, arginfo_TPlCharset_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlCharset(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlCharset_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlCharset", TPlCharset_methods);
	if (NULL == TInterfacedObject_ce_ptr)
		Register_TInterfacedObject(TSRMLS_C);
	TPlCharset_ce_ptr = zend_register_internal_class_ex(&ce, TInterfacedObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlTableCharset_ce_ptr = NULL;

SB_PHP_METHOD(TPlTableCharset, CanConvert)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TPlTableCharset_CanConvert(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlTableCharset, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlTableCharset_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlTableCharset, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlTableCharset_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlTableCharset, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlTableCharset_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlTableCharset, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlTableCharset_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlTableCharset, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlTableCharset_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlTableCharset, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlTableCharset_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlTableCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset_CanConvert, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlTableCharset_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlTableCharset_methods[] = {
	PHP_ME(TPlTableCharset, CanConvert, arginfo_TPlTableCharset_CanConvert, ZEND_ACC_PUBLIC)
	PHP_ME(TPlTableCharset, ConvertFromUCS, arginfo_TPlTableCharset_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlTableCharset, ConvertToUCS, arginfo_TPlTableCharset_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlTableCharset, ConvertBufferToUCS, arginfo_TPlTableCharset_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlTableCharset, ClassType, arginfo_TPlTableCharset_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlTableCharset, __construct, arginfo_TPlTableCharset___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlTableCharset, CreateForFinalize, arginfo_TPlTableCharset_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlTableCharset(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlTableCharset_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlTableCharset", TPlTableCharset_methods);
	if (NULL == TPlCharset_ce_ptr)
		Register_TPlCharset(TSRMLS_C);
	TPlTableCharset_ce_ptr = zend_register_internal_class_ex(&ce, TPlCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlMixedCharset_ce_ptr = NULL;

SB_PHP_METHOD(TPlMixedCharset, CanConvert)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TPlMixedCharset_CanConvert(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlMixedCharset, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlMixedCharset_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlMixedCharset, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlMixedCharset_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlMixedCharset, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlMixedCharset_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlMixedCharset, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlMixedCharset_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlMixedCharset, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlMixedCharset_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlMixedCharset, CreateShift)
{
	long l4Shift;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Shift) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlMixedCharset_CreateShift((int32_t)l4Shift, &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlMixedCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset_CanConvert, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlMixedCharset_CreateShift, 0, 0, 1)
	ZEND_ARG_INFO(0, Shift)
ZEND_END_ARG_INFO()

static zend_function_entry TPlMixedCharset_methods[] = {
	PHP_ME(TPlMixedCharset, CanConvert, arginfo_TPlMixedCharset_CanConvert, ZEND_ACC_PUBLIC)
	PHP_ME(TPlMixedCharset, ConvertFromUCS, arginfo_TPlMixedCharset_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlMixedCharset, ConvertToUCS, arginfo_TPlMixedCharset_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlMixedCharset, ConvertBufferToUCS, arginfo_TPlMixedCharset_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlMixedCharset, ClassType, arginfo_TPlMixedCharset_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlMixedCharset, __construct, arginfo_TPlMixedCharset___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlMixedCharset, CreateShift, arginfo_TPlMixedCharset_CreateShift, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlMixedCharset(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlMixedCharset_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlMixedCharset", TPlMixedCharset_methods);
	if (NULL == TPlCharset_ce_ptr)
		Register_TPlCharset(TSRMLS_C);
	TPlMixedCharset_ce_ptr = zend_register_internal_class_ex(&ce, TPlCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlConvertingCharset_ce_ptr = NULL;

SB_PHP_METHOD(TPlConvertingCharset, CanConvert)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TPlConvertingCharset_CanConvert(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvertingCharset, ConvertFromUCS)
{
	long u4Char;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Char) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlConvertingCharset_ConvertFromUCS(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Char, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvertingCharset, ConvertToUCS)
{
	uint32_t u4CharRaw = 0;
	zval *oStream;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oStream, TStream_ce_ptr, &zu4Char) == SUCCESS) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TPlConvertingCharset_ConvertToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvertingCharset, ConvertBufferToUCS)
{
	long l4Count;
	SBPointerZValInfo piBuf;
	uint32_t u4CharRaw = 0;
	zend_bool bIsLastChunk;
	zval *zpBuf;
	zval *zu4Char;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlbz", &zpBuf, &l4Count, &bIsLastChunk, &zu4Char) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zu4Char) && (IS_LONG == Z_TYPE_P(zu4Char)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TPlConvertingCharset_ConvertBufferToUCS(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, (int32_t)l4Count, (int8_t)bIsLastChunk, &u4CharRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zu4Char, (long)u4CharRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvertingCharset, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConvertingCharset_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlConvertingCharset, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlConvertingCharset_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvertingCharset_CanConvert, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvertingCharset_ConvertFromUCS, 0, 0, 1)
	ZEND_ARG_INFO(0, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvertingCharset_ConvertToUCS, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvertingCharset_ConvertBufferToUCS, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, IsLastChunk)
	ZEND_ARG_INFO(1, Char)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvertingCharset_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlConvertingCharset___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlConvertingCharset_methods[] = {
	PHP_ME(TPlConvertingCharset, CanConvert, arginfo_TPlConvertingCharset_CanConvert, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvertingCharset, ConvertFromUCS, arginfo_TPlConvertingCharset_ConvertFromUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvertingCharset, ConvertToUCS, arginfo_TPlConvertingCharset_ConvertToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvertingCharset, ConvertBufferToUCS, arginfo_TPlConvertingCharset_ConvertBufferToUCS, ZEND_ACC_PUBLIC)
	PHP_ME(TPlConvertingCharset, ClassType, arginfo_TPlConvertingCharset_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlConvertingCharset, __construct, arginfo_TPlConvertingCharset___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TPlConvertingCharset(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlConvertingCharset_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlConvertingCharset", TPlConvertingCharset_methods);
	if (NULL == TPlCharset_ce_ptr)
		Register_TPlCharset(TSRMLS_C);
	TPlConvertingCharset_ce_ptr = zend_register_internal_class_ex(&ce, TPlCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlASCII_ce_ptr = NULL;

SB_PHP_METHOD(TPlASCII, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlASCII_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2090684966, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlASCII, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlASCII_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1255183235, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlASCII, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlASCII_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlASCII, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlASCII_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlASCII, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlASCII_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlTableCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlASCII_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlASCII_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlASCII_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlASCII___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlASCII_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlASCII_methods[] = {
	PHP_ME(TPlASCII, GetCategory, arginfo_TPlASCII_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlASCII, GetDescription, arginfo_TPlASCII_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlASCII, ClassType, arginfo_TPlASCII_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlASCII, __construct, arginfo_TPlASCII___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlASCII, CreateForFinalize, arginfo_TPlASCII_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlASCII(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlASCII_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlASCII", TPlASCII_methods);
	if (NULL == TPlTableCharset_ce_ptr)
		Register_TPlTableCharset(TSRMLS_C);
	TPlASCII_ce_ptr = zend_register_internal_class_ex(&ce, TPlTableCharset_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TPlISO_8859_1_ce_ptr = NULL;

SB_PHP_METHOD(TPlISO_8859_1, GetCategory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlISO_8859_1_GetCategory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(611523414, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlISO_8859_1, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TPlISO_8859_1_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1167430327, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlISO_8859_1, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlISO_8859_1_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlISO_8859_1, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlISO_8859_1_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TPlISO_8859_1, CreateForFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TPlISO_8859_1_CreateForFinalize(&hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TPlTableCharset_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlISO_8859_1_GetCategory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlISO_8859_1_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlISO_8859_1_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlISO_8859_1___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TPlISO_8859_1_CreateForFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TPlISO_8859_1_methods[] = {
	PHP_ME(TPlISO_8859_1, GetCategory, arginfo_TPlISO_8859_1_GetCategory, ZEND_ACC_PUBLIC)
	PHP_ME(TPlISO_8859_1, GetDescription, arginfo_TPlISO_8859_1_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TPlISO_8859_1, ClassType, arginfo_TPlISO_8859_1_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TPlISO_8859_1, __construct, arginfo_TPlISO_8859_1___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TPlISO_8859_1, CreateForFinalize, arginfo_TPlISO_8859_1_CreateForFinalize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPlISO_8859_1(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPlISO_8859_1_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TPlISO_8859_1", TPlISO_8859_1_methods);
	if (NULL == TPlASCII_ce_ptr)
		Register_TPlASCII(TSRMLS_C);
	TPlISO_8859_1_ce_ptr = zend_register_internal_class_ex(&ce, TPlASCII_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBChSConvBase, RegisterCharset)
{
	zval *oCharsetClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCharsetClass, TPlCharsetClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBChSConvBase_RegisterCharset(SBGetObjectHandle(oCharsetClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPlCharsetClass)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConvBase, UnregisterCharset)
{
	zval *oCharsetClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCharsetClass, TPlCharsetClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBChSConvBase_UnregisterCharset(SBGetObjectHandle(oCharsetClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPlCharsetClass)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConvBase, RegisterCharsetLibrary)
{
	zval *zRegistrationProc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zRegistrationProc) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zRegistrationProc))))
	{
		SBCheckError(SBChSConvBase_RegisterCharsetLibrary(NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConvBase, AbstractError)
{
	char *sClassName;
	char *sMethod;
	int sClassName_len;
	int sMethod_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sClassName, &sClassName_len, &sMethod, &sMethod_len) == SUCCESS)
	{
		SBCheckError(SBChSConvBase_AbstractError(sClassName, (int32_t)sClassName_len, sMethod, (int32_t)sMethod_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSConvBase, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBChSConvBase_Initialize() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBChSConvBase_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCS_Count, SB_UCS_Count, SB_UCS_Count);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCSCharByteOrderLE32, SB_UCSCharByteOrderLE32, SB_UCSCharByteOrderLE32);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCSCharByteOrderBE32, SB_UCSCharByteOrderBE32, SB_UCSCharByteOrderBE32);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCSCharByteOrderLE16, SB_UCSCharByteOrderLE16, SB_UCSCharByteOrderLE16);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCSCharByteOrderBE16, SB_UCSCharByteOrderBE16, SB_UCSCharByteOrderBE16);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCSCharIgnore, SB_UCSCharIgnore, SB_UCSCharIgnore);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, UCSCharIllegal, SB_UCSCharIllegal, SB_UCSCharIllegal);
	SB_REGISTER_LONG_CONSTANT(SBChSConvBase, SB_MAX_CHARACTER_LENGTH, SB_MAX_CHARACTER_LENGTH, SB_MAX_CHARACTER_LENGTH);
	SB_REGISTER_NULL_CONSTANT(SBChSConvBase, cNilPrefixes, SB_cNilPrefixes);
	SB_REGISTER_NULL_CONSTANT(SBChSConvBase, cNilHiBytes, SB_cNilHiBytes);
	SB_REGISTER_NULL_CONSTANT(SBChSConvBase, cNilConvTable, SB_cNilConvTable);
}

void Register_SBChSConvBase_Aliases(TSRMLS_D)
{
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	zend_register_class_alias("SBChSConvBase_TElNativeStream", TStream_ce_ptr);
	IPlConvBuffer_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("IPlConvBuffer", IPlConvBuffer_ce_ptr);
	IPlCharset_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("IPlCharset", IPlCharset_ce_ptr);
	TPlCharsetClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TPlCharsetClass", TPlCharsetClass_ce_ptr);
}

