#include "sbhmac.h"

SB_PHP_METHOD(TMACMD5Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMACMD5Context));
		intern->len = sizeof(TMACMD5Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMACMD5Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMACMD5Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TMACMD5Context, get_Size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 208);
}

SB_PHP_METHOD(TMACMD5Context, set_Size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 208);
}

SB_PHP_METHOD(TMACMD5Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 276);
}

SB_PHP_METHOD(TMACMD5Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 276);
}

SB_PHP_METHOD(TMACMD5Context, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 280);
}

SB_PHP_METHOD(TMACMD5Context, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 280);
}

SB_PHP_METHOD(TMACMD5Context, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 284);
}

SB_PHP_METHOD(TMACMD5Context, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 284);
}

SB_PHP_METHOD(TMACMD5Context, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 288);
}

SB_PHP_METHOD(TMACMD5Context, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 288);
}

SB_PHP_METHOD(TMACMD5Context, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 292);
}

SB_PHP_METHOD(TMACMD5Context, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 292);
}

zend_class_entry *TMACMD5Context_ce_ptr = NULL;

static zend_function_entry TMACMD5Context_methods[] = {
	PHP_ME(TMACMD5Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMACMD5Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACMD5Context, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMACMD5Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMACMD5Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMACMD5Context", TMACMD5Context_methods);
	TMACMD5Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMACSHA1Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMACSHA1Context));
		intern->len = sizeof(TMACSHA1Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMACSHA1Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMACSHA1Context));
}

SB_PHP_METHOD(TMACSHA1Context, get_Size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 212);
}

SB_PHP_METHOD(TMACSHA1Context, set_Size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 212);
}

SB_PHP_METHOD(TMACSHA1Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 280);
}

SB_PHP_METHOD(TMACSHA1Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 280);
}

SB_PHP_METHOD(TMACSHA1Context, get_A)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 284);
}

SB_PHP_METHOD(TMACSHA1Context, set_A)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 284);
}

SB_PHP_METHOD(TMACSHA1Context, get_B)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 288);
}

SB_PHP_METHOD(TMACSHA1Context, set_B)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 288);
}

SB_PHP_METHOD(TMACSHA1Context, get_C)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 292);
}

SB_PHP_METHOD(TMACSHA1Context, set_C)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 292);
}

SB_PHP_METHOD(TMACSHA1Context, get_D)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 296);
}

SB_PHP_METHOD(TMACSHA1Context, set_D)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 296);
}

SB_PHP_METHOD(TMACSHA1Context, get_E)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 300);
}

SB_PHP_METHOD(TMACSHA1Context, set_E)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 300);
}

zend_class_entry *TMACSHA1Context_ce_ptr = NULL;

static zend_function_entry TMACSHA1Context_methods[] = {
	PHP_ME(TMACSHA1Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TMACSHA1Context, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, get_A, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_A, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, get_B, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_B, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, get_C, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_C, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, get_D, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_D, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, get_E, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA1Context, set_E, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TMACSHA1Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMACSHA1Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMACSHA1Context", TMACSHA1Context_methods);
	TMACSHA1Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMACSHA256Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMACSHA256Context));
		intern->len = sizeof(TMACSHA256Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMACSHA256Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMACSHA256Context));
}

zend_class_entry *TMACSHA256Context_ce_ptr = NULL;

static zend_function_entry TMACSHA256Context_methods[] = {
	PHP_ME(TMACSHA256Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA256Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TMACSHA256Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMACSHA256Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMACSHA256Context", TMACSHA256Context_methods);
	TMACSHA256Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TMACSHA512Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TMACSHA512Context));
		intern->len = sizeof(TMACSHA512Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TMACSHA512Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TMACSHA512Context));
}

zend_class_entry *TMACSHA512Context_ce_ptr = NULL;

static zend_function_entry TMACSHA512Context_methods[] = {
	PHP_ME(TMACSHA512Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TMACSHA512Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TMACSHA512Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TMACSHA512Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TMACSHA512Context", TMACSHA512Context_methods);
	TMACSHA512Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBHMAC, InitializeMACMD5)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TMACMD5Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_InitializeMACMD5((TMACMD5Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACMD5Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, FinalizeMACMD5)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMACMD5Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest128 roOutResult;
		SBCheckError(SBHMAC_FinalizeMACMD5((TMACMD5Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACMD5Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, HashMACMD5)
{
	long u4Count;
	long u4Size;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *oStream;
	zval *zaKey;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaS, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACMD5(aiS.data, aiS.len, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zl", &oStream, TStream_ce_ptr, &zaKey, &u4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACMD5_1(SBGetObjectHandle(oStream TSRMLS_CC), aiKey.data, aiKey.len, (uint32_t)u4Count, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zpBuffer, &u4Size, &zaKey) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest128 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACMD5_2(piBuffer.data, (uint32_t)u4Size, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest128_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest128) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMACMD5Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACMD5_3((TMACMD5Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL) or (TStream, array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL) or (&TMACMD5Context, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, InitializeMACSHA1)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TMACSHA1Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_InitializeMACSHA1((TMACSHA1Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA1Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, FinalizeMACSHA1)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMACSHA1Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest160 roOutResult;
		SBCheckError(SBHMAC_FinalizeMACSHA1((TMACSHA1Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA1Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, HashMACSHA1)
{
	long u4Count;
	long u4Size;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *oStream;
	zval *zaKey;
	zval *zaS;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zl", &oStream, TStream_ce_ptr, &zaKey, &u4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest160 roOutResult;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA1(SBGetObjectHandle(oStream TSRMLS_CC), aiKey.data, aiKey.len, (uint32_t)u4Count, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlz", &zpBuffer, &u4Size, &zaKey) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest160 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA1_1(piBuffer.data, (uint32_t)u4Size, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMACSHA1Context_ce_ptr, &zpChunk, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA1_2((TMACSHA1Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaS, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest160 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA1_3(aiS.data, aiS.len, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL) or (&TMACSHA1Context, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, InitializeMACSHA256)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TMACSHA256Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_InitializeMACSHA256((TMACSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA256Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, FinalizeMACSHA256)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMACSHA256Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest256 roOutResult;
		SBCheckError(SBHMAC_FinalizeMACSHA256((TMACSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest256_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest256) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA256Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, HashMACSHA256)
{
	long l4Size;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaKey;
	zval *zaS;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMACSHA256Context_ce_ptr, &zpChunk, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA256((TMACSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaS, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest256 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA256_1(aiS.data, aiS.len, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest256_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest256) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA256Context, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, InitializeMACSHA512)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TMACSHA512Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_InitializeMACSHA512((TMACSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA512Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, FinalizeMACSHA512)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMACSHA512Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest512 roOutResult;
		SBCheckError(SBHMAC_FinalizeMACSHA512((TMACSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest512_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest512) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA512Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, HashMACSHA512)
{
	long l4Size;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaKey;
	zval *zaS;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMACSHA512Context_ce_ptr, &zpChunk, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA512((TMACSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaS, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest512 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA512_1(aiS.data, aiS.len, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest512_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest512) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA512Context, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, InitializeMACSHA224)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TMACSHA256Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_InitializeMACSHA224((TMACSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA256Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, FinalizeMACSHA224)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMACSHA256Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest224 roOutResult;
		SBCheckError(SBHMAC_FinalizeMACSHA224((TMACSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest224_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest224) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA256Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, HashMACSHA224)
{
	long l4Size;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaKey;
	zval *zaS;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMACSHA256Context_ce_ptr, &zpChunk, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA224((TMACSHA256Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaS, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest224 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA224_1(aiS.data, aiS.len, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest224_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest224) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA256Context, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, InitializeMACSHA384)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TMACSHA512Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_InitializeMACSHA384((TMACSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA512Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, FinalizeMACSHA384)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TMACSHA512Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest384 roOutResult;
		SBCheckError(SBHMAC_FinalizeMACSHA384((TMACSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest384_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest384) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA512Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBHMAC, HashMACSHA384)
{
	long l4Size;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiS;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaKey;
	zval *zaS;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TMACSHA512Context_ce_ptr, &zpChunk, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA384((TMACSHA512Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaS, &zaKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TMessageDigest384 roOutResult;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBHMAC_HashMACSHA384_1(aiS.data, aiS.len, aiKey.data, aiKey.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		SBFreeArrayZValInfo(&aiKey);
		object_init_ex(return_value, TMessageDigest384_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest384) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TMACSHA512Context, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

void Register_SBHMAC_Aliases(TSRMLS_D)
{
	if (NULL == TMACSHA256Context_ce_ptr)
		Register_TMACSHA256Context(TSRMLS_C);
	zend_register_class_alias("TMACSHA224Context", TMACSHA256Context_ce_ptr);
	if (NULL == TMACSHA512Context_ce_ptr)
		Register_TMACSHA512Context(TSRMLS_C);
	zend_register_class_alias("TMACSHA384Context", TMACSHA512Context_ce_ptr);
}

