#include "sbsslconstants.h"

zend_class_entry *TSBVersion_ce_ptr = NULL;

zend_class_entry *TSBVersions_ce_ptr = NULL;

SB_PHP_METHOD(TSSLVersion, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSSLVersion));
		intern->len = sizeof(TSSLVersion);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSSLVersion, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSSLVersion));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSSLVersion, get_Major)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSLVersion, set_Major)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSSLVersion, get_Minor)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TSSLVersion, set_Minor)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

zend_class_entry *TSSLVersion_ce_ptr = NULL;

static zend_function_entry TSSLVersion_methods[] = {
	PHP_ME(TSSLVersion, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLVersion, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSSLVersion, get_Major, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLVersion, set_Major, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLVersion, get_Minor, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSSLVersion, set_Minor, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSSLVersion(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSSLVersion_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSSLVersion", TSSLVersion_methods);
	TSSLVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBCertificateTypeExtension_ce_ptr = NULL;

zend_class_entry *TElSSLCertificateType_ce_ptr = NULL;

zend_class_entry *TElOpenPGPCertDescriptorType_ce_ptr = NULL;

void Register_SBSSLConstants_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_FACILITY_SSL, SB_ERROR_FACILITY_SSL, SB_ERROR_FACILITY_SSL);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_PROTOCOL_ERROR_FLAG, SB_ERROR_SSL_PROTOCOL_ERROR_FLAG, SB_ERROR_SSL_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CONNECTION_CANCELLED_BY_USER, SB_ERROR_SSL_CONNECTION_CANCELLED_BY_USER, SB_ERROR_SSL_CONNECTION_CANCELLED_BY_USER);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_TIMEOUT, SB_ERROR_SSL_TIMEOUT, SB_ERROR_SSL_TIMEOUT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNSUPPORTED_MAC_ALGORITHM, SB_ERROR_SSL_UNSUPPORTED_MAC_ALGORITHM, SB_ERROR_SSL_UNSUPPORTED_MAC_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CLIENT_KEX_COMPUTATION_ERROR, SB_ERROR_SSL_CLIENT_KEX_COMPUTATION_ERROR, SB_ERROR_SSL_CLIENT_KEX_COMPUTATION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_COMPRESSION_ERROR, SB_ERROR_SSL_COMPRESSION_ERROR, SB_ERROR_SSL_COMPRESSION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CRYPTO_NOT_INITIALIZED, SB_ERROR_SSL_CRYPTO_NOT_INITIALIZED, SB_ERROR_SSL_CRYPTO_NOT_INITIALIZED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_PRIVATE_KEY_OPERATION_FAILED, SB_ERROR_SSL_PRIVATE_KEY_OPERATION_FAILED, SB_ERROR_SSL_PRIVATE_KEY_OPERATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNEXPECTED_MESSAGE, SB_ERROR_SSL_UNEXPECTED_MESSAGE, SB_ERROR_SSL_UNEXPECTED_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_BAD_RECORD_MAC, SB_ERROR_SSL_BAD_RECORD_MAC, SB_ERROR_SSL_BAD_RECORD_MAC);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_DECRYPTION_FAILED, SB_ERROR_SSL_DECRYPTION_FAILED, SB_ERROR_SSL_DECRYPTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_RECORD_OVERFLOW, SB_ERROR_SSL_RECORD_OVERFLOW, SB_ERROR_SSL_RECORD_OVERFLOW);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_DECOMPRESSION_FAILURE, SB_ERROR_SSL_DECOMPRESSION_FAILURE, SB_ERROR_SSL_DECOMPRESSION_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_HANDSHAKE_FAILURE, SB_ERROR_SSL_HANDSHAKE_FAILURE, SB_ERROR_SSL_HANDSHAKE_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_NO_CERTIFICATE, SB_ERROR_SSL_NO_CERTIFICATE, SB_ERROR_SSL_NO_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_BAD_CERTIFICATE, SB_ERROR_SSL_BAD_CERTIFICATE, SB_ERROR_SSL_BAD_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNSUPPORTED_CERTIFICATE, SB_ERROR_SSL_UNSUPPORTED_CERTIFICATE, SB_ERROR_SSL_UNSUPPORTED_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CERTIFICATE_REVOKED, SB_ERROR_SSL_CERTIFICATE_REVOKED, SB_ERROR_SSL_CERTIFICATE_REVOKED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CERTIFICATE_EXPIRED, SB_ERROR_SSL_CERTIFICATE_EXPIRED, SB_ERROR_SSL_CERTIFICATE_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CERTIFICATE_UNKNOWN, SB_ERROR_SSL_CERTIFICATE_UNKNOWN, SB_ERROR_SSL_CERTIFICATE_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_ILLEGAL_PARAMETER, SB_ERROR_SSL_ILLEGAL_PARAMETER, SB_ERROR_SSL_ILLEGAL_PARAMETER);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNKNOWN_CA, SB_ERROR_SSL_UNKNOWN_CA, SB_ERROR_SSL_UNKNOWN_CA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_ACCESS_DENIED, SB_ERROR_SSL_ACCESS_DENIED, SB_ERROR_SSL_ACCESS_DENIED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_DECODE_ERROR, SB_ERROR_SSL_DECODE_ERROR, SB_ERROR_SSL_DECODE_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_DECRYPT_ERROR, SB_ERROR_SSL_DECRYPT_ERROR, SB_ERROR_SSL_DECRYPT_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_EXPORT_RESTRICTION, SB_ERROR_SSL_EXPORT_RESTRICTION, SB_ERROR_SSL_EXPORT_RESTRICTION);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_PROTOCOL_VERSION, SB_ERROR_SSL_PROTOCOL_VERSION, SB_ERROR_SSL_PROTOCOL_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_INSUFFICIENT_SECURITY, SB_ERROR_SSL_INSUFFICIENT_SECURITY, SB_ERROR_SSL_INSUFFICIENT_SECURITY);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_INTERNAL_ERROR, SB_ERROR_SSL_INTERNAL_ERROR, SB_ERROR_SSL_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_USER_CANCELED, SB_ERROR_SSL_USER_CANCELED, SB_ERROR_SSL_USER_CANCELED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_NO_RENEGOTIATION, SB_ERROR_SSL_NO_RENEGOTIATION, SB_ERROR_SSL_NO_RENEGOTIATION);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_CLOSE_NOTIFY, SB_ERROR_SSL_CLOSE_NOTIFY, SB_ERROR_SSL_CLOSE_NOTIFY);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNKNOWN_PROTOCOL_ERROR, SB_ERROR_SSL_UNKNOWN_PROTOCOL_ERROR, SB_ERROR_SSL_UNKNOWN_PROTOCOL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNSUPPORTED_EXTENSION, SB_ERROR_SSL_UNSUPPORTED_EXTENSION, SB_ERROR_SSL_UNSUPPORTED_EXTENSION);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_NO_SHARED_CIPHER, SB_ERROR_SSL_NO_SHARED_CIPHER, SB_ERROR_SSL_NO_SHARED_CIPHER);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_INAPPROPRIATE_FALLBACK, SB_ERROR_SSL_INAPPROPRIATE_FALLBACK, SB_ERROR_SSL_INAPPROPRIATE_FALLBACK);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, ERROR_SSL_UNKNOWN_PSK_IDENTITY, SB_ERROR_SSL_UNKNOWN_PSK_IDENTITY, SB_ERROR_SSL_UNKNOWN_PSK_IDENTITY);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_FIRST, SB_SUITE_FIRST, SB_SUITE_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_NULL_NULL_NULL, SB_SUITE_NULL_NULL_NULL, SB_SUITE_NULL_NULL_NULL);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_NULL_MD5, SB_SUITE_RSA_NULL_MD5, SB_SUITE_RSA_NULL_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_NULL_SHA, SB_SUITE_RSA_NULL_SHA, SB_SUITE_RSA_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_RC4_MD5, SB_SUITE_RSA_RC4_MD5, SB_SUITE_RSA_RC4_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_RC4_SHA, SB_SUITE_RSA_RC4_SHA, SB_SUITE_RSA_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_RC2_MD5, SB_SUITE_RSA_RC2_MD5, SB_SUITE_RSA_RC2_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_IDEA_MD5, SB_SUITE_RSA_IDEA_MD5, SB_SUITE_RSA_IDEA_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_IDEA_SHA, SB_SUITE_RSA_IDEA_SHA, SB_SUITE_RSA_IDEA_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_DES_MD5, SB_SUITE_RSA_DES_MD5, SB_SUITE_RSA_DES_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_DES_SHA, SB_SUITE_RSA_DES_SHA, SB_SUITE_RSA_DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_3DES_MD5, SB_SUITE_RSA_3DES_MD5, SB_SUITE_RSA_3DES_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_3DES_SHA, SB_SUITE_RSA_3DES_SHA, SB_SUITE_RSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_AES128_SHA, SB_SUITE_RSA_AES128_SHA, SB_SUITE_RSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_AES256_SHA, SB_SUITE_RSA_AES256_SHA, SB_SUITE_RSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_DES_SHA, SB_SUITE_DH_DSS_DES_SHA, SB_SUITE_DH_DSS_DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_3DES_SHA, SB_SUITE_DH_DSS_3DES_SHA, SB_SUITE_DH_DSS_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_AES128_SHA, SB_SUITE_DH_DSS_AES128_SHA, SB_SUITE_DH_DSS_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_AES256_SHA, SB_SUITE_DH_DSS_AES256_SHA, SB_SUITE_DH_DSS_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_DES_SHA, SB_SUITE_DH_RSA_DES_SHA, SB_SUITE_DH_RSA_DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_3DES_SHA, SB_SUITE_DH_RSA_3DES_SHA, SB_SUITE_DH_RSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_AES128_SHA, SB_SUITE_DH_RSA_AES128_SHA, SB_SUITE_DH_RSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_AES256_SHA, SB_SUITE_DH_RSA_AES256_SHA, SB_SUITE_DH_RSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_DES_SHA, SB_SUITE_DHE_DSS_DES_SHA, SB_SUITE_DHE_DSS_DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_3DES_SHA, SB_SUITE_DHE_DSS_3DES_SHA, SB_SUITE_DHE_DSS_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_AES128_SHA, SB_SUITE_DHE_DSS_AES128_SHA, SB_SUITE_DHE_DSS_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_AES256_SHA, SB_SUITE_DHE_DSS_AES256_SHA, SB_SUITE_DHE_DSS_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_DES_SHA, SB_SUITE_DHE_RSA_DES_SHA, SB_SUITE_DHE_RSA_DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_3DES_SHA, SB_SUITE_DHE_RSA_3DES_SHA, SB_SUITE_DHE_RSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_AES128_SHA, SB_SUITE_DHE_RSA_AES128_SHA, SB_SUITE_DHE_RSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_AES256_SHA, SB_SUITE_DHE_RSA_AES256_SHA, SB_SUITE_DHE_RSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_RC4_MD5, SB_SUITE_DH_ANON_RC4_MD5, SB_SUITE_DH_ANON_RC4_MD5);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_DES_SHA, SB_SUITE_DH_ANON_DES_SHA, SB_SUITE_DH_ANON_DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_3DES_SHA, SB_SUITE_DH_ANON_3DES_SHA, SB_SUITE_DH_ANON_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_AES128_SHA, SB_SUITE_DH_ANON_AES128_SHA, SB_SUITE_DH_ANON_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_AES256_SHA, SB_SUITE_DH_ANON_AES256_SHA, SB_SUITE_DH_ANON_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_RC2_MD5_EXPORT, SB_SUITE_RSA_RC2_MD5_EXPORT, SB_SUITE_RSA_RC2_MD5_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_RC4_MD5_EXPORT, SB_SUITE_RSA_RC4_MD5_EXPORT, SB_SUITE_RSA_RC4_MD5_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_DES_SHA_EXPORT, SB_SUITE_RSA_DES_SHA_EXPORT, SB_SUITE_RSA_DES_SHA_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_DES_SHA_EXPORT, SB_SUITE_DH_DSS_DES_SHA_EXPORT, SB_SUITE_DH_DSS_DES_SHA_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_DES_SHA_EXPORT, SB_SUITE_DH_RSA_DES_SHA_EXPORT, SB_SUITE_DH_RSA_DES_SHA_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_DES_SHA_EXPORT, SB_SUITE_DHE_DSS_DES_SHA_EXPORT, SB_SUITE_DHE_DSS_DES_SHA_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_DES_SHA_EXPORT, SB_SUITE_DHE_RSA_DES_SHA_EXPORT, SB_SUITE_DHE_RSA_DES_SHA_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_RC4_MD5_EXPORT, SB_SUITE_DH_ANON_RC4_MD5_EXPORT, SB_SUITE_DH_ANON_RC4_MD5_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_DES_SHA_EXPORT, SB_SUITE_DH_ANON_DES_SHA_EXPORT, SB_SUITE_DH_ANON_DES_SHA_EXPORT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_CAMELLIA128_SHA, SB_SUITE_RSA_CAMELLIA128_SHA, SB_SUITE_RSA_CAMELLIA128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_CAMELLIA128_SHA, SB_SUITE_DH_DSS_CAMELLIA128_SHA, SB_SUITE_DH_DSS_CAMELLIA128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_CAMELLIA128_SHA, SB_SUITE_DH_RSA_CAMELLIA128_SHA, SB_SUITE_DH_RSA_CAMELLIA128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_CAMELLIA128_SHA, SB_SUITE_DHE_DSS_CAMELLIA128_SHA, SB_SUITE_DHE_DSS_CAMELLIA128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CAMELLIA128_SHA, SB_SUITE_DHE_RSA_CAMELLIA128_SHA, SB_SUITE_DHE_RSA_CAMELLIA128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_CAMELLIA128_SHA, SB_SUITE_DH_ANON_CAMELLIA128_SHA, SB_SUITE_DH_ANON_CAMELLIA128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_CAMELLIA256_SHA, SB_SUITE_RSA_CAMELLIA256_SHA, SB_SUITE_RSA_CAMELLIA256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_CAMELLIA256_SHA, SB_SUITE_DH_DSS_CAMELLIA256_SHA, SB_SUITE_DH_DSS_CAMELLIA256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_CAMELLIA256_SHA, SB_SUITE_DH_RSA_CAMELLIA256_SHA, SB_SUITE_DH_RSA_CAMELLIA256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_CAMELLIA256_SHA, SB_SUITE_DHE_DSS_CAMELLIA256_SHA, SB_SUITE_DHE_DSS_CAMELLIA256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CAMELLIA256_SHA, SB_SUITE_DHE_RSA_CAMELLIA256_SHA, SB_SUITE_DHE_RSA_CAMELLIA256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_CAMELLIA256_SHA, SB_SUITE_DH_ANON_CAMELLIA256_SHA, SB_SUITE_DH_ANON_CAMELLIA256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_RC4_SHA, SB_SUITE_PSK_RC4_SHA, SB_SUITE_PSK_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_3DES_SHA, SB_SUITE_PSK_3DES_SHA, SB_SUITE_PSK_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_AES128_SHA, SB_SUITE_PSK_AES128_SHA, SB_SUITE_PSK_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_AES256_SHA, SB_SUITE_PSK_AES256_SHA, SB_SUITE_PSK_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_RC4_SHA, SB_SUITE_DHE_PSK_RC4_SHA, SB_SUITE_DHE_PSK_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_3DES_SHA, SB_SUITE_DHE_PSK_3DES_SHA, SB_SUITE_DHE_PSK_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_AES128_SHA, SB_SUITE_DHE_PSK_AES128_SHA, SB_SUITE_DHE_PSK_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_AES256_SHA, SB_SUITE_DHE_PSK_AES256_SHA, SB_SUITE_DHE_PSK_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_RC4_SHA, SB_SUITE_RSA_PSK_RC4_SHA, SB_SUITE_RSA_PSK_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_3DES_SHA, SB_SUITE_RSA_PSK_3DES_SHA, SB_SUITE_RSA_PSK_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_AES128_SHA, SB_SUITE_RSA_PSK_AES128_SHA, SB_SUITE_RSA_PSK_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_AES256_SHA, SB_SUITE_RSA_PSK_AES256_SHA, SB_SUITE_RSA_PSK_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_SEED_SHA, SB_SUITE_RSA_SEED_SHA, SB_SUITE_RSA_SEED_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_SEED_SHA, SB_SUITE_DH_DSS_SEED_SHA, SB_SUITE_DH_DSS_SEED_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_SEED_SHA, SB_SUITE_DH_RSA_SEED_SHA, SB_SUITE_DH_RSA_SEED_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_SEED_SHA, SB_SUITE_DHE_DSS_SEED_SHA, SB_SUITE_DHE_DSS_SEED_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_SEED_SHA, SB_SUITE_DHE_RSA_SEED_SHA, SB_SUITE_DHE_RSA_SEED_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_SEED_SHA, SB_SUITE_DH_ANON_SEED_SHA, SB_SUITE_DH_ANON_SEED_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_3DES_SHA, SB_SUITE_SRP_SHA_3DES_SHA, SB_SUITE_SRP_SHA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_RSA_3DES_SHA, SB_SUITE_SRP_SHA_RSA_3DES_SHA, SB_SUITE_SRP_SHA_RSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_DSS_3DES_SHA, SB_SUITE_SRP_SHA_DSS_3DES_SHA, SB_SUITE_SRP_SHA_DSS_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_AES128_SHA, SB_SUITE_SRP_SHA_AES128_SHA, SB_SUITE_SRP_SHA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_RSA_AES128_SHA, SB_SUITE_SRP_SHA_RSA_AES128_SHA, SB_SUITE_SRP_SHA_RSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_DSS_AES128_SHA, SB_SUITE_SRP_SHA_DSS_AES128_SHA, SB_SUITE_SRP_SHA_DSS_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_AES256_SHA, SB_SUITE_SRP_SHA_AES256_SHA, SB_SUITE_SRP_SHA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_RSA_AES256_SHA, SB_SUITE_SRP_SHA_RSA_AES256_SHA, SB_SUITE_SRP_SHA_RSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SRP_SHA_DSS_AES256_SHA, SB_SUITE_SRP_SHA_DSS_AES256_SHA, SB_SUITE_SRP_SHA_DSS_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_NULL_SHA, SB_SUITE_ECDH_ECDSA_NULL_SHA, SB_SUITE_ECDH_ECDSA_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_RC4_SHA, SB_SUITE_ECDH_ECDSA_RC4_SHA, SB_SUITE_ECDH_ECDSA_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_3DES_SHA, SB_SUITE_ECDH_ECDSA_3DES_SHA, SB_SUITE_ECDH_ECDSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_AES128_SHA, SB_SUITE_ECDH_ECDSA_AES128_SHA, SB_SUITE_ECDH_ECDSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_AES256_SHA, SB_SUITE_ECDH_ECDSA_AES256_SHA, SB_SUITE_ECDH_ECDSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_NULL_SHA, SB_SUITE_ECDHE_ECDSA_NULL_SHA, SB_SUITE_ECDHE_ECDSA_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_RC4_SHA, SB_SUITE_ECDHE_ECDSA_RC4_SHA, SB_SUITE_ECDHE_ECDSA_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_3DES_SHA, SB_SUITE_ECDHE_ECDSA_3DES_SHA, SB_SUITE_ECDHE_ECDSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_AES128_SHA, SB_SUITE_ECDHE_ECDSA_AES128_SHA, SB_SUITE_ECDHE_ECDSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_AES256_SHA, SB_SUITE_ECDHE_ECDSA_AES256_SHA, SB_SUITE_ECDHE_ECDSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_NULL_SHA, SB_SUITE_ECDH_RSA_NULL_SHA, SB_SUITE_ECDH_RSA_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_RC4_SHA, SB_SUITE_ECDH_RSA_RC4_SHA, SB_SUITE_ECDH_RSA_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_3DES_SHA, SB_SUITE_ECDH_RSA_3DES_SHA, SB_SUITE_ECDH_RSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_AES128_SHA, SB_SUITE_ECDH_RSA_AES128_SHA, SB_SUITE_ECDH_RSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_AES256_SHA, SB_SUITE_ECDH_RSA_AES256_SHA, SB_SUITE_ECDH_RSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_NULL_SHA, SB_SUITE_ECDHE_RSA_NULL_SHA, SB_SUITE_ECDHE_RSA_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_RC4_SHA, SB_SUITE_ECDHE_RSA_RC4_SHA, SB_SUITE_ECDHE_RSA_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_3DES_SHA, SB_SUITE_ECDHE_RSA_3DES_SHA, SB_SUITE_ECDHE_RSA_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_AES128_SHA, SB_SUITE_ECDHE_RSA_AES128_SHA, SB_SUITE_ECDHE_RSA_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_AES256_SHA, SB_SUITE_ECDHE_RSA_AES256_SHA, SB_SUITE_ECDHE_RSA_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ANON_NULL_SHA, SB_SUITE_ECDH_ANON_NULL_SHA, SB_SUITE_ECDH_ANON_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ANON_RC4_SHA, SB_SUITE_ECDH_ANON_RC4_SHA, SB_SUITE_ECDH_ANON_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ANON_3DES_SHA, SB_SUITE_ECDH_ANON_3DES_SHA, SB_SUITE_ECDH_ANON_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ANON_AES128_SHA, SB_SUITE_ECDH_ANON_AES128_SHA, SB_SUITE_ECDH_ANON_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ANON_AES256_SHA, SB_SUITE_ECDH_ANON_AES256_SHA, SB_SUITE_ECDH_ANON_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PRE_TLS12_LAST, SB_SUITE_PRE_TLS12_LAST, SB_SUITE_PRE_TLS12_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_NULL_SHA256, SB_SUITE_RSA_NULL_SHA256, SB_SUITE_RSA_NULL_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_AES128_SHA256, SB_SUITE_RSA_AES128_SHA256, SB_SUITE_RSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_AES256_SHA256, SB_SUITE_RSA_AES256_SHA256, SB_SUITE_RSA_AES256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_AES128_SHA256, SB_SUITE_DH_DSS_AES128_SHA256, SB_SUITE_DH_DSS_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_AES128_SHA256, SB_SUITE_DH_RSA_AES128_SHA256, SB_SUITE_DH_RSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_AES128_SHA256, SB_SUITE_DHE_DSS_AES128_SHA256, SB_SUITE_DHE_DSS_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_AES128_SHA256, SB_SUITE_DHE_RSA_AES128_SHA256, SB_SUITE_DHE_RSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_AES256_SHA256, SB_SUITE_DH_DSS_AES256_SHA256, SB_SUITE_DH_DSS_AES256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_AES256_SHA256, SB_SUITE_DH_RSA_AES256_SHA256, SB_SUITE_DH_RSA_AES256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_AES256_SHA256, SB_SUITE_DHE_DSS_AES256_SHA256, SB_SUITE_DHE_DSS_AES256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_AES256_SHA256, SB_SUITE_DHE_RSA_AES256_SHA256, SB_SUITE_DHE_RSA_AES256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_AES128_SHA256, SB_SUITE_DH_ANON_AES128_SHA256, SB_SUITE_DH_ANON_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_AES256_SHA256, SB_SUITE_DH_ANON_AES256_SHA256, SB_SUITE_DH_ANON_AES256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_AES128_GCM_SHA256, SB_SUITE_RSA_AES128_GCM_SHA256, SB_SUITE_RSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_AES256_GCM_SHA384, SB_SUITE_RSA_AES256_GCM_SHA384, SB_SUITE_RSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_AES128_GCM_SHA256, SB_SUITE_DHE_RSA_AES128_GCM_SHA256, SB_SUITE_DHE_RSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_AES256_GCM_SHA384, SB_SUITE_DHE_RSA_AES256_GCM_SHA384, SB_SUITE_DHE_RSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_AES128_GCM_SHA256, SB_SUITE_DH_RSA_AES128_GCM_SHA256, SB_SUITE_DH_RSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_AES256_GCM_SHA384, SB_SUITE_DH_RSA_AES256_GCM_SHA384, SB_SUITE_DH_RSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_AES128_GCM_SHA256, SB_SUITE_DHE_DSS_AES128_GCM_SHA256, SB_SUITE_DHE_DSS_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_AES256_GCM_SHA384, SB_SUITE_DHE_DSS_AES256_GCM_SHA384, SB_SUITE_DHE_DSS_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_AES128_GCM_SHA256, SB_SUITE_DH_DSS_AES128_GCM_SHA256, SB_SUITE_DH_DSS_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_AES256_GCM_SHA384, SB_SUITE_DH_DSS_AES256_GCM_SHA384, SB_SUITE_DH_DSS_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_AES128_GCM_SHA256, SB_SUITE_DH_ANON_AES128_GCM_SHA256, SB_SUITE_DH_ANON_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_AES256_GCM_SHA384, SB_SUITE_DH_ANON_AES256_GCM_SHA384, SB_SUITE_DH_ANON_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_AES128_SHA256, SB_SUITE_ECDHE_ECDSA_AES128_SHA256, SB_SUITE_ECDHE_ECDSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_AES256_SHA384, SB_SUITE_ECDHE_ECDSA_AES256_SHA384, SB_SUITE_ECDHE_ECDSA_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_AES128_SHA256, SB_SUITE_ECDH_ECDSA_AES128_SHA256, SB_SUITE_ECDH_ECDSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_AES256_SHA384, SB_SUITE_ECDH_ECDSA_AES256_SHA384, SB_SUITE_ECDH_ECDSA_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_AES128_SHA256, SB_SUITE_ECDHE_RSA_AES128_SHA256, SB_SUITE_ECDHE_RSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_AES256_SHA384, SB_SUITE_ECDHE_RSA_AES256_SHA384, SB_SUITE_ECDHE_RSA_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_AES128_SHA256, SB_SUITE_ECDH_RSA_AES128_SHA256, SB_SUITE_ECDH_RSA_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_AES256_SHA384, SB_SUITE_ECDH_RSA_AES256_SHA384, SB_SUITE_ECDH_RSA_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_AES128_GCM_SHA256, SB_SUITE_ECDHE_ECDSA_AES128_GCM_SHA256, SB_SUITE_ECDHE_ECDSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_AES256_GCM_SHA384, SB_SUITE_ECDHE_ECDSA_AES256_GCM_SHA384, SB_SUITE_ECDHE_ECDSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_AES128_GCM_SHA256, SB_SUITE_ECDH_ECDSA_AES128_GCM_SHA256, SB_SUITE_ECDH_ECDSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_AES256_GCM_SHA384, SB_SUITE_ECDH_ECDSA_AES256_GCM_SHA384, SB_SUITE_ECDH_ECDSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_AES128_GCM_SHA256, SB_SUITE_ECDHE_RSA_AES128_GCM_SHA256, SB_SUITE_ECDHE_RSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_AES256_GCM_SHA384, SB_SUITE_ECDHE_RSA_AES256_GCM_SHA384, SB_SUITE_ECDHE_RSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_AES128_GCM_SHA256, SB_SUITE_ECDH_RSA_AES128_GCM_SHA256, SB_SUITE_ECDH_RSA_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_AES256_GCM_SHA384, SB_SUITE_ECDH_RSA_AES256_GCM_SHA384, SB_SUITE_ECDH_RSA_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_AES128_GCM_SHA256, SB_SUITE_PSK_AES128_GCM_SHA256, SB_SUITE_PSK_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_AES256_GCM_SHA384, SB_SUITE_PSK_AES256_GCM_SHA384, SB_SUITE_PSK_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_AES128_GCM_SHA256, SB_SUITE_DHE_PSK_AES128_GCM_SHA256, SB_SUITE_DHE_PSK_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_AES256_GCM_SHA384, SB_SUITE_DHE_PSK_AES256_GCM_SHA384, SB_SUITE_DHE_PSK_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_AES128_GCM_SHA256, SB_SUITE_RSA_PSK_AES128_GCM_SHA256, SB_SUITE_RSA_PSK_AES128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_AES256_GCM_SHA384, SB_SUITE_RSA_PSK_AES256_GCM_SHA384, SB_SUITE_RSA_PSK_AES256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_AES128_SHA256, SB_SUITE_PSK_AES128_SHA256, SB_SUITE_PSK_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_AES256_SHA384, SB_SUITE_PSK_AES256_SHA384, SB_SUITE_PSK_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_NULL_SHA256, SB_SUITE_PSK_NULL_SHA256, SB_SUITE_PSK_NULL_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_NULL_SHA384, SB_SUITE_PSK_NULL_SHA384, SB_SUITE_PSK_NULL_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_AES128_SHA256, SB_SUITE_DHE_PSK_AES128_SHA256, SB_SUITE_DHE_PSK_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_AES256_SHA384, SB_SUITE_DHE_PSK_AES256_SHA384, SB_SUITE_DHE_PSK_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_NULL_SHA256, SB_SUITE_DHE_PSK_NULL_SHA256, SB_SUITE_DHE_PSK_NULL_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_NULL_SHA384, SB_SUITE_DHE_PSK_NULL_SHA384, SB_SUITE_DHE_PSK_NULL_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_AES128_SHA256, SB_SUITE_RSA_PSK_AES128_SHA256, SB_SUITE_RSA_PSK_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_AES256_SHA384, SB_SUITE_RSA_PSK_AES256_SHA384, SB_SUITE_RSA_PSK_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_NULL_SHA256, SB_SUITE_RSA_PSK_NULL_SHA256, SB_SUITE_RSA_PSK_NULL_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_NULL_SHA384, SB_SUITE_RSA_PSK_NULL_SHA384, SB_SUITE_RSA_PSK_NULL_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_CAMELLIA128_SHA256, SB_SUITE_RSA_CAMELLIA128_SHA256, SB_SUITE_RSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_CAMELLIA128_SHA256, SB_SUITE_DH_DSS_CAMELLIA128_SHA256, SB_SUITE_DH_DSS_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_CAMELLIA128_SHA256, SB_SUITE_DH_RSA_CAMELLIA128_SHA256, SB_SUITE_DH_RSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_CAMELLIA128_SHA256, SB_SUITE_DHE_DSS_CAMELLIA128_SHA256, SB_SUITE_DHE_DSS_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CAMELLIA128_SHA256, SB_SUITE_DHE_RSA_CAMELLIA128_SHA256, SB_SUITE_DHE_RSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_CAMELLIA128_SHA256, SB_SUITE_DH_ANON_CAMELLIA128_SHA256, SB_SUITE_DH_ANON_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_CAMELLIA256_SHA256, SB_SUITE_RSA_CAMELLIA256_SHA256, SB_SUITE_RSA_CAMELLIA256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_CAMELLIA256_SHA256, SB_SUITE_DH_DSS_CAMELLIA256_SHA256, SB_SUITE_DH_DSS_CAMELLIA256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_CAMELLIA256_SHA256, SB_SUITE_DH_RSA_CAMELLIA256_SHA256, SB_SUITE_DH_RSA_CAMELLIA256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_CAMELLIA256_SHA256, SB_SUITE_DHE_DSS_CAMELLIA256_SHA256, SB_SUITE_DHE_DSS_CAMELLIA256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CAMELLIA256_SHA256, SB_SUITE_DHE_RSA_CAMELLIA256_SHA256, SB_SUITE_DHE_RSA_CAMELLIA256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_ANON_CAMELLIA256_SHA256, SB_SUITE_DH_ANON_CAMELLIA256_SHA256, SB_SUITE_DH_ANON_CAMELLIA256_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_CAMELLIA128_SHA256, SB_SUITE_ECDHE_ECDSA_CAMELLIA128_SHA256, SB_SUITE_ECDHE_ECDSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_CAMELLIA256_SHA384, SB_SUITE_ECDHE_ECDSA_CAMELLIA256_SHA384, SB_SUITE_ECDHE_ECDSA_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_CAMELLIA128_SHA256, SB_SUITE_ECDH_ECDSA_CAMELLIA128_SHA256, SB_SUITE_ECDH_ECDSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_CAMELLIA256_SHA384, SB_SUITE_ECDH_ECDSA_CAMELLIA256_SHA384, SB_SUITE_ECDH_ECDSA_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_CAMELLIA128_SHA256, SB_SUITE_ECDHE_RSA_CAMELLIA128_SHA256, SB_SUITE_ECDHE_RSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_CAMELLIA256_SHA384, SB_SUITE_ECDHE_RSA_CAMELLIA256_SHA384, SB_SUITE_ECDHE_RSA_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_CAMELLIA128_SHA256, SB_SUITE_ECDH_RSA_CAMELLIA128_SHA256, SB_SUITE_ECDH_RSA_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_CAMELLIA256_SHA384, SB_SUITE_ECDH_RSA_CAMELLIA256_SHA384, SB_SUITE_ECDH_RSA_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_RSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_RSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_DHE_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_DHE_RSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_DHE_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_DHE_RSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_DH_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_DH_RSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_DH_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_DH_RSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_CAMELLIA128_GCM_SHA256, SB_SUITE_DHE_DSS_CAMELLIA128_GCM_SHA256, SB_SUITE_DHE_DSS_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_DSS_CAMELLIA256_GCM_SHA384, SB_SUITE_DHE_DSS_CAMELLIA256_GCM_SHA384, SB_SUITE_DHE_DSS_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_CAMELLIA128_GCM_SHA256, SB_SUITE_DH_DSS_CAMELLIA128_GCM_SHA256, SB_SUITE_DH_DSS_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_DSS_CAMELLIA256_GCM_SHA384, SB_SUITE_DH_DSS_CAMELLIA256_GCM_SHA384, SB_SUITE_DH_DSS_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_anon_CAMELLIA128_GCM_SHA256, SB_SUITE_DH_anon_CAMELLIA128_GCM_SHA256, SB_SUITE_DH_anon_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DH_anon_CAMELLIA256_GCM_SHA384, SB_SUITE_DH_anon_CAMELLIA256_GCM_SHA384, SB_SUITE_DH_anon_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDHE_ECDSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDHE_ECDSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDHE_ECDSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDHE_ECDSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDH_ECDSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDH_ECDSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_ECDSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDH_ECDSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDH_ECDSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDHE_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDHE_RSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDHE_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDHE_RSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDH_RSA_CAMELLIA128_GCM_SHA256, SB_SUITE_ECDH_RSA_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDH_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDH_RSA_CAMELLIA256_GCM_SHA384, SB_SUITE_ECDH_RSA_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_CAMELLIA128_GCM_SHA256, SB_SUITE_PSK_CAMELLIA128_GCM_SHA256, SB_SUITE_PSK_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_CAMELLIA256_GCM_SHA384, SB_SUITE_PSK_CAMELLIA256_GCM_SHA384, SB_SUITE_PSK_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_CAMELLIA128_GCM_SHA256, SB_SUITE_DHE_PSK_CAMELLIA128_GCM_SHA256, SB_SUITE_DHE_PSK_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_CAMELLIA256_GCM_SHA384, SB_SUITE_DHE_PSK_CAMELLIA256_GCM_SHA384, SB_SUITE_DHE_PSK_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_CAMELLIA128_GCM_SHA256, SB_SUITE_RSA_PSK_CAMELLIA128_GCM_SHA256, SB_SUITE_RSA_PSK_CAMELLIA128_GCM_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_CAMELLIA256_GCM_SHA384, SB_SUITE_RSA_PSK_CAMELLIA256_GCM_SHA384, SB_SUITE_RSA_PSK_CAMELLIA256_GCM_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_CAMELLIA128_SHA256, SB_SUITE_PSK_CAMELLIA128_SHA256, SB_SUITE_PSK_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_PSK_CAMELLIA256_SHA384, SB_SUITE_PSK_CAMELLIA256_SHA384, SB_SUITE_PSK_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_CAMELLIA128_SHA256, SB_SUITE_DHE_PSK_CAMELLIA128_SHA256, SB_SUITE_DHE_PSK_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_PSK_CAMELLIA256_SHA384, SB_SUITE_DHE_PSK_CAMELLIA256_SHA384, SB_SUITE_DHE_PSK_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_CAMELLIA128_SHA256, SB_SUITE_RSA_PSK_CAMELLIA128_SHA256, SB_SUITE_RSA_PSK_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_RSA_PSK_CAMELLIA256_SHA384, SB_SUITE_RSA_PSK_CAMELLIA256_SHA384, SB_SUITE_RSA_PSK_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_CAMELLIA128_SHA256, SB_SUITE_ECDHE_PSK_CAMELLIA128_SHA256, SB_SUITE_ECDHE_PSK_CAMELLIA128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_CAMELLIA256_SHA384, SB_SUITE_ECDHE_PSK_CAMELLIA256_SHA384, SB_SUITE_ECDHE_PSK_CAMELLIA256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_RC4_SHA, SB_SUITE_ECDHE_PSK_RC4_SHA, SB_SUITE_ECDHE_PSK_RC4_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_3DES_SHA, SB_SUITE_ECDHE_PSK_3DES_SHA, SB_SUITE_ECDHE_PSK_3DES_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_AES128_SHA, SB_SUITE_ECDHE_PSK_AES128_SHA, SB_SUITE_ECDHE_PSK_AES128_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_AES256_SHA, SB_SUITE_ECDHE_PSK_AES256_SHA, SB_SUITE_ECDHE_PSK_AES256_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_AES128_SHA256, SB_SUITE_ECDHE_PSK_AES128_SHA256, SB_SUITE_ECDHE_PSK_AES128_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_AES256_SHA384, SB_SUITE_ECDHE_PSK_AES256_SHA384, SB_SUITE_ECDHE_PSK_AES256_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_NULL_SHA, SB_SUITE_ECDHE_PSK_NULL_SHA, SB_SUITE_ECDHE_PSK_NULL_SHA);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_NULL_SHA256, SB_SUITE_ECDHE_PSK_NULL_SHA256, SB_SUITE_ECDHE_PSK_NULL_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_PSK_NULL_SHA384, SB_SUITE_ECDHE_PSK_NULL_SHA384, SB_SUITE_ECDHE_PSK_NULL_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_RSA_CHACHA20_POLY1305_SHA256, SB_SUITE_ECDHE_RSA_CHACHA20_POLY1305_SHA256, SB_SUITE_ECDHE_RSA_CHACHA20_POLY1305_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_ECDHE_ECDSA_CHACHA20_POLY1305_SHA256, SB_SUITE_ECDHE_ECDSA_CHACHA20_POLY1305_SHA256, SB_SUITE_ECDHE_ECDSA_CHACHA20_POLY1305_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_DHE_RSA_CHACHA20_POLY1305_SHA256, SB_SUITE_DHE_RSA_CHACHA20_POLY1305_SHA256, SB_SUITE_DHE_RSA_CHACHA20_POLY1305_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_LAST, SB_SUITE_LAST, SB_SUITE_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_UNKNOWN, SB_SUITE_UNKNOWN, SB_SUITE_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SECURITY_LEVEL_INSECURE, SB_SUITE_SECURITY_LEVEL_INSECURE, SB_SUITE_SECURITY_LEVEL_INSECURE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SECURITY_LEVEL_LOW, SB_SUITE_SECURITY_LEVEL_LOW, SB_SUITE_SECURITY_LEVEL_LOW);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SECURITY_LEVEL_ACCEPTABLE, SB_SUITE_SECURITY_LEVEL_ACCEPTABLE, SB_SUITE_SECURITY_LEVEL_ACCEPTABLE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SECURITY_LEVEL_NORMAL, SB_SUITE_SECURITY_LEVEL_NORMAL, SB_SUITE_SECURITY_LEVEL_NORMAL);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SECURITY_LEVEL_HIGH, SB_SUITE_SECURITY_LEVEL_HIGH, SB_SUITE_SECURITY_LEVEL_HIGH);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_SUITE_SECURITY_LEVEL_HIGHEST, SB_SUITE_SECURITY_LEVEL_HIGHEST, SB_SUITE_SECURITY_LEVEL_HIGHEST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_CA_FIRST, SB_SSL_CA_FIRST, SB_SSL_CA_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_CA_NONE, SB_SSL_CA_NONE, SB_SSL_CA_NONE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_CA_ZLIB, SB_SSL_CA_ZLIB, SB_SSL_CA_ZLIB);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_CA_LAST, SB_SSL_CA_LAST, SB_SSL_CA_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_SERVER_NAME, SB_SSL_EXT_SERVER_NAME, SB_SSL_EXT_SERVER_NAME);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_MAX_FRAGMENT_LENGTH, SB_SSL_EXT_MAX_FRAGMENT_LENGTH, SB_SSL_EXT_MAX_FRAGMENT_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_CLIENT_CERT_URL, SB_SSL_EXT_CLIENT_CERT_URL, SB_SSL_EXT_CLIENT_CERT_URL);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_TRUSTED_CA_KEYS, SB_SSL_EXT_TRUSTED_CA_KEYS, SB_SSL_EXT_TRUSTED_CA_KEYS);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_TRUNCATED_HMAC, SB_SSL_EXT_TRUNCATED_HMAC, SB_SSL_EXT_TRUNCATED_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_STATUS_REQUEST, SB_SSL_EXT_STATUS_REQUEST, SB_SSL_EXT_STATUS_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_USER_NAME, SB_SSL_EXT_USER_NAME, SB_SSL_EXT_USER_NAME);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_CERTIFICATE_TYPE, SB_SSL_EXT_CERTIFICATE_TYPE, SB_SSL_EXT_CERTIFICATE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_EC_CURVES, SB_SSL_EXT_EC_CURVES, SB_SSL_EXT_EC_CURVES);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_EC_POINTS_FORMAT, SB_SSL_EXT_EC_POINTS_FORMAT, SB_SSL_EXT_EC_POINTS_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_SRP, SB_SSL_EXT_SRP, SB_SSL_EXT_SRP);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_SESSION_TICKET, SB_SSL_EXT_SESSION_TICKET, SB_SSL_EXT_SESSION_TICKET);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_CERT_HASH_TYPES, SB_SSL_EXT_CERT_HASH_TYPES, SB_SSL_EXT_CERT_HASH_TYPES);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_RENEGOTIATION_INFO, SB_SSL_EXT_RENEGOTIATION_INFO, SB_SSL_EXT_RENEGOTIATION_INFO);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_HEARTBEAT_HELLO, SB_SSL_EXT_HEARTBEAT_HELLO, SB_SSL_EXT_HEARTBEAT_HELLO);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_SIGNATURE_ALGORITHMS, SB_SSL_EXT_SIGNATURE_ALGORITHMS, SB_SSL_EXT_SIGNATURE_ALGORITHMS);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_STATUS_REQUEST_V2, SB_SSL_EXT_STATUS_REQUEST_V2, SB_SSL_EXT_STATUS_REQUEST_V2);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_CLIENT_CERTIFICATE_TYPE, SB_SSL_EXT_CLIENT_CERTIFICATE_TYPE, SB_SSL_EXT_CLIENT_CERTIFICATE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_SERVER_CERTIFICATE_TYPE, SB_SSL_EXT_SERVER_CERTIFICATE_TYPE, SB_SSL_EXT_SERVER_CERTIFICATE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SSL_EXT_EXTENDED_MASTER_SECRET, SB_SSL_EXT_EXTENDED_MASTER_SECRET, SB_SSL_EXT_EXTENDED_MASTER_SECRET);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_HEARTBEAT_MODE_PEER_ALLOWED_TO_SEND, SB_HEARTBEAT_MODE_PEER_ALLOWED_TO_SEND, SB_HEARTBEAT_MODE_PEER_ALLOWED_TO_SEND);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_HEARTBEAT_MODE_PEER_NOT_ALLOWED_TO_SEND, SB_HEARTBEAT_MODE_PEER_NOT_ALLOWED_TO_SEND, SB_HEARTBEAT_MODE_PEER_NOT_ALLOWED_TO_SEND);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_HEARTBEAT_REQUEST, SB_HEARTBEAT_REQUEST, SB_HEARTBEAT_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_HEARTBEAT_RESPONSE, SB_HEARTBEAT_RESPONSE, SB_HEARTBEAT_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_NAMED_CURVE_FIRST, SB_EC_TLS_NAMED_CURVE_FIRST, SB_EC_TLS_NAMED_CURVE_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT163K1, SB_EC_TLS_SECT163K1, SB_EC_TLS_SECT163K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT163R1, SB_EC_TLS_SECT163R1, SB_EC_TLS_SECT163R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT163R2, SB_EC_TLS_SECT163R2, SB_EC_TLS_SECT163R2);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT193R1, SB_EC_TLS_SECT193R1, SB_EC_TLS_SECT193R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT193R2, SB_EC_TLS_SECT193R2, SB_EC_TLS_SECT193R2);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT233K1, SB_EC_TLS_SECT233K1, SB_EC_TLS_SECT233K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT233R1, SB_EC_TLS_SECT233R1, SB_EC_TLS_SECT233R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT239K1, SB_EC_TLS_SECT239K1, SB_EC_TLS_SECT239K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT283K1, SB_EC_TLS_SECT283K1, SB_EC_TLS_SECT283K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT283R1, SB_EC_TLS_SECT283R1, SB_EC_TLS_SECT283R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT409K1, SB_EC_TLS_SECT409K1, SB_EC_TLS_SECT409K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT409R1, SB_EC_TLS_SECT409R1, SB_EC_TLS_SECT409R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT571K1, SB_EC_TLS_SECT571K1, SB_EC_TLS_SECT571K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECT571R1, SB_EC_TLS_SECT571R1, SB_EC_TLS_SECT571R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP160K1, SB_EC_TLS_SECP160K1, SB_EC_TLS_SECP160K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP160R1, SB_EC_TLS_SECP160R1, SB_EC_TLS_SECP160R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP160R2, SB_EC_TLS_SECP160R2, SB_EC_TLS_SECP160R2);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP192K1, SB_EC_TLS_SECP192K1, SB_EC_TLS_SECP192K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP192R1, SB_EC_TLS_SECP192R1, SB_EC_TLS_SECP192R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP224K1, SB_EC_TLS_SECP224K1, SB_EC_TLS_SECP224K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP224R1, SB_EC_TLS_SECP224R1, SB_EC_TLS_SECP224R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP256K1, SB_EC_TLS_SECP256K1, SB_EC_TLS_SECP256K1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP256R1, SB_EC_TLS_SECP256R1, SB_EC_TLS_SECP256R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP384R1, SB_EC_TLS_SECP384R1, SB_EC_TLS_SECP384R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_SECP521R1, SB_EC_TLS_SECP521R1, SB_EC_TLS_SECP521R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_BRAINPOOLP256R1, SB_EC_TLS_BRAINPOOLP256R1, SB_EC_TLS_BRAINPOOLP256R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_BRAINPOOLP384R1, SB_EC_TLS_BRAINPOOLP384R1, SB_EC_TLS_BRAINPOOLP384R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_BRAINPOOLP512R1, SB_EC_TLS_BRAINPOOLP512R1, SB_EC_TLS_BRAINPOOLP512R1);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_NAMED_CURVE_LAST, SB_EC_TLS_NAMED_CURVE_LAST, SB_EC_TLS_NAMED_CURVE_LAST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_ARBITRARY_EXPLICIT_PRIME_CURVES, SB_EC_TLS_ARBITRARY_EXPLICIT_PRIME_CURVES, SB_EC_TLS_ARBITRARY_EXPLICIT_PRIME_CURVES);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_ARBITRARY_EXPLICIT_CHAR2_CURVES, SB_EC_TLS_ARBITRARY_EXPLICIT_CHAR2_CURVES, SB_EC_TLS_ARBITRARY_EXPLICIT_CHAR2_CURVES);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_POINT_FORMAT_FIRST, SB_EC_TLS_POINT_FORMAT_FIRST, SB_EC_TLS_POINT_FORMAT_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_POINT_UNCOMPRESSED, SB_EC_TLS_POINT_UNCOMPRESSED, SB_EC_TLS_POINT_UNCOMPRESSED);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_POINT_COMPRESSED_PRIME, SB_EC_TLS_POINT_COMPRESSED_PRIME, SB_EC_TLS_POINT_COMPRESSED_PRIME);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_POINT_COMPRESSED_CHAR2, SB_EC_TLS_POINT_COMPRESSED_CHAR2, SB_EC_TLS_POINT_COMPRESSED_CHAR2);
	SB_REGISTER_LONG_CONSTANT(SBSSLConstants, SB_EC_TLS_POINT_FORMAT_LAST, SB_EC_TLS_POINT_FORMAT_LAST, SB_EC_TLS_POINT_FORMAT_LAST);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SLayer2ProtocolError, SB_SLayer2ProtocolError, SB_SLayer2ProtocolError);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SUnknownCipherSuite, SB_SUnknownCipherSuite, SB_SUnknownCipherSuite);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SUnknownMessage, SB_SUnknownMessage, SB_SUnknownMessage);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SServerVerifyFailed, SB_SServerVerifyFailed, SB_SServerVerifyFailed);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SUnknownError, SB_SUnknownError, SB_SUnknownError);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SNoCipher, SB_SNoCipher, SB_SNoCipher);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SNoCertificate, SB_SNoCertificate, SB_SNoCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SBadCertificate, SB_SBadCertificate, SB_SBadCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SUnsupportedCertificate, SB_SUnsupportedCertificate, SB_SUnsupportedCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SHandshakeFailure, SB_SHandshakeFailure, SB_SHandshakeFailure);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SInvalidMAC, SB_SInvalidMAC, SB_SInvalidMAC);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SInvalidClientCertificate, SB_SInvalidClientCertificate, SB_SInvalidClientCertificate);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SDecryptError, SB_SDecryptError, SB_SDecryptError);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_CLNT, SB_SSL_CLNT, SB_SSL_CLNT);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_SRVR, SB_SSL_SRVR, SB_SSL_SRVR);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_MASTER_SECRET, SB_SSL_MASTER_SECRET, SB_SSL_MASTER_SECRET);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_EXTENDED_MASTER_SECRET, SB_SSL_EXTENDED_MASTER_SECRET, SB_SSL_EXTENDED_MASTER_SECRET);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_KEY_EXPANSION, SB_SSL_KEY_EXPANSION, SB_SSL_KEY_EXPANSION);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_CLIENT_WRITE_KEY, SB_SSL_CLIENT_WRITE_KEY, SB_SSL_CLIENT_WRITE_KEY);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_SERVER_WRITE_KEY, SB_SSL_SERVER_WRITE_KEY, SB_SSL_SERVER_WRITE_KEY);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_IV_BLOCK, SB_SSL_IV_BLOCK, SB_SSL_IV_BLOCK);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_CLIENT_FINISHED, SB_SSL_CLIENT_FINISHED, SB_SSL_CLIENT_FINISHED);
	SB_REGISTER_STRING_CONSTANT(SBSSLConstants, SB_SSL_SERVER_FINISHED, SB_SSL_SERVER_FINISHED, SB_SSL_SERVER_FINISHED);
}

void Register_SBSSLConstants_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBVersion", NULL);
	TSBVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBVersion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBVersion_ce_ptr, "sbSSL2", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersion_ce_ptr, "sbSSL3", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersion_ce_ptr, "sbTLS1", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersion_ce_ptr, "sbTLS11", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersion_ce_ptr, "sbTLS12", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBVersions", NULL);
	TSBVersions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBVersions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBVersions_ce_ptr, "sbSSL2", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersions_ce_ptr, "sbSSL3", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersions_ce_ptr, "sbTLS1", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersions_ce_ptr, "sbTLS11", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBVersions_ce_ptr, "sbTLS12", 16)
	
	INIT_CLASS_ENTRY(ce, "TSBCertificateTypeExtension", NULL);
	TSBCertificateTypeExtension_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCertificateTypeExtension_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateTypeExtension_ce_ptr, "cteAuto", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateTypeExtension_ce_ptr, "cteOld", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateTypeExtension_ce_ptr, "cteNew", 2)
	
	INIT_CLASS_ENTRY(ce, "TElSSLCertificateType", NULL);
	TElSSLCertificateType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElSSLCertificateType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElSSLCertificateType_ce_ptr, "ctX509", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElSSLCertificateType_ce_ptr, "ctPGP", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElSSLCertificateType_ce_ptr, "ctRawKey", 2)
	
	INIT_CLASS_ENTRY(ce, "TElOpenPGPCertDescriptorType", NULL);
	TElOpenPGPCertDescriptorType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElOpenPGPCertDescriptorType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElOpenPGPCertDescriptorType_ce_ptr, "ctPGP_Cert_Fingerprint", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElOpenPGPCertDescriptorType_ce_ptr, "ctPGP_Cert", 1)
}

