#include "sbumac.h"

SB_PHP_METHOD(TNHContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TNHContext));
		intern->len = sizeof(TNHContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TNHContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TNHContext));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TNHContext, get_Next_Data_Empty)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TNHContext, set_Next_Data_Empty)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TNHContext, get_Bytes_Hashed)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(TNHContext, set_Bytes_Hashed)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *TNHContext_ce_ptr = NULL;

static zend_function_entry TNHContext_methods[] = {
	PHP_ME(TNHContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TNHContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TNHContext, get_Next_Data_Empty, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TNHContext, set_Next_Data_Empty, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TNHContext, get_Bytes_Hashed, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TNHContext, set_Bytes_Hashed, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TNHContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TNHContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TNHContext", TNHContext_methods);
	TNHContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TUHASHContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TUHASHContext));
		intern->len = sizeof(TUHASHContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TUHASHContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TUHASHContext));
}

SB_PHP_METHOD(TUHASHContext, get_Msg_Len)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(TUHASHContext, set_Msg_Len)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

zend_class_entry *TUHASHContext_ce_ptr = NULL;

static zend_function_entry TUHASHContext_methods[] = {
	PHP_ME(TUHASHContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TUHASHContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TUHASHContext, get_Msg_Len, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TUHASHContext, set_Msg_Len, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TUHASHContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TUHASHContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TUHASHContext", TUHASHContext_methods);
	TUHASHContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TPDFContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TPDFContext));
		intern->len = sizeof(TPDFContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TPDFContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TPDFContext));
}

zend_class_entry *TPDFContext_ce_ptr = NULL;

static zend_function_entry TPDFContext_methods[] = {
	PHP_ME(TPDFContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TPDFContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TPDFContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TPDFContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TPDFContext", TPDFContext_methods);
	TPDFContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElUMAC_ce_ptr = NULL;

SB_PHP_METHOD(TElUMAC, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUMAC_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElUMAC_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUMAC, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElUMAC_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUMAC, Update)
{
	long l4Size;
	long u4Len;
	long u4StartIndex;
	SBArrayZValInfo aiIn_Buf;
	SBArrayZValInfo piIn_Buf;
	zval *zaIn_Buf;
	zval *zpIn_Buf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaIn_Buf, &u4StartIndex, &u4Len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaIn_Buf)) || (IS_ARRAY == Z_TYPE_P(zaIn_Buf)) || (IS_NULL == Z_TYPE_P(zaIn_Buf))))
	{
		if (!SBGetByteArrayFromZVal(zaIn_Buf, &aiIn_Buf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElUMAC_Update(SBGetObjectHandle(getThis() TSRMLS_CC), aiIn_Buf.data, aiIn_Buf.len, (uint32_t)u4StartIndex, (uint32_t)u4Len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiIn_Buf);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpIn_Buf, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpIn_Buf) == IS_STRING) || (Z_TYPE_P(zpIn_Buf) == IS_ARRAY) || (Z_TYPE_P(zpIn_Buf) == IS_NULL) || ((Z_TYPE_P(zpIn_Buf) == IS_OBJECT) && (Z_OBJCE_P(zpIn_Buf) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpIn_Buf, &piIn_Buf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElUMAC_Update_1(SBGetObjectHandle(getThis() TSRMLS_CC), piIn_Buf.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piIn_Buf);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUMAC, Final_)
{
	SBArrayZValInfo aiNonce;
	SBArrayZValInfo aiTag;
	uint32_t _err;
	zval *zaNonce;
	zval *zaTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaNonce, &zaTag) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaNonce)) || (IS_ARRAY == Z_TYPE_P(zaNonce)) || (IS_NULL == Z_TYPE_P(zaNonce))) && PZVAL_IS_REF(zaTag) && ((IS_STRING == Z_TYPE_P(zaTag)) || (IS_ARRAY == Z_TYPE_P(zaTag))))
	{
		if (!SBGetByteArrayFromZVal(zaNonce, &aiNonce TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiTag);
		_err = TElUMAC_Final_(SBGetObjectHandle(getThis() TSRMLS_CC), aiNonce.data, aiNonce.len, aiTag.data, &aiTag.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaTag, &aiTag TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1367165572, 2, aiTag.data, &aiTag.len) TSRMLS_CC);
			((char *)aiTag.data)[aiTag.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiTag);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiNonce);
		SBSetByteArrayToZVal(&aiTag, zaTag);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUMAC, Calculate)
{
	long u4Len;
	long u4StartIndex;
	SBArrayZValInfo aiIn_Buf;
	SBArrayZValInfo aiNonce;
	SBArrayZValInfo aiTag;
	SBArrayZValInfo piIn_Buf;
	uint32_t _err;
	zval *zaIn_Buf;
	zval *zaNonce;
	zval *zaTag;
	zval *zpIn_Buf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzz", &zaIn_Buf, &u4StartIndex, &u4Len, &zaNonce, &zaTag) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaIn_Buf)) || (IS_ARRAY == Z_TYPE_P(zaIn_Buf)) || (IS_NULL == Z_TYPE_P(zaIn_Buf))) && ((IS_STRING == Z_TYPE_P(zaNonce)) || (IS_ARRAY == Z_TYPE_P(zaNonce)) || (IS_NULL == Z_TYPE_P(zaNonce))) && PZVAL_IS_REF(zaTag) && ((IS_STRING == Z_TYPE_P(zaTag)) || (IS_ARRAY == Z_TYPE_P(zaTag))))
	{
		if (!SBGetByteArrayFromZVal(zaIn_Buf, &aiIn_Buf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaNonce, &aiNonce TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiTag);
		_err = TElUMAC_Calculate(SBGetObjectHandle(getThis() TSRMLS_CC), aiIn_Buf.data, aiIn_Buf.len, (uint32_t)u4StartIndex, (uint32_t)u4Len, aiNonce.data, aiNonce.len, aiTag.data, &aiTag.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaTag, &aiTag TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1154190704, 5, aiTag.data, &aiTag.len) TSRMLS_CC);
			((char *)aiTag.data)[aiTag.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiTag);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiIn_Buf);
		SBFreeArrayZValInfo(&aiNonce);
		SBSetByteArrayToZVal(&aiTag, zaTag);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpIn_Buf, &u4Len, &zaNonce, &zaTag) == SUCCESS) && ((Z_TYPE_P(zpIn_Buf) == IS_STRING) || (Z_TYPE_P(zpIn_Buf) == IS_ARRAY) || (Z_TYPE_P(zpIn_Buf) == IS_NULL) || ((Z_TYPE_P(zpIn_Buf) == IS_OBJECT) && (Z_OBJCE_P(zpIn_Buf) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaNonce)) || (IS_ARRAY == Z_TYPE_P(zaNonce)) || (IS_NULL == Z_TYPE_P(zaNonce))) && PZVAL_IS_REF(zaTag) && ((IS_STRING == Z_TYPE_P(zaTag)) || (IS_ARRAY == Z_TYPE_P(zaTag))))
	{
		if (!SBGetPointerFromZVal(zpIn_Buf, &piIn_Buf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaNonce, &aiNonce TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiTag);
		_err = TElUMAC_Calculate_1(SBGetObjectHandle(getThis() TSRMLS_CC), piIn_Buf.data, (uint32_t)u4Len, aiNonce.data, aiNonce.len, aiTag.data, &aiTag.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaTag, &aiTag TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1563207301, 4, aiTag.data, &aiTag.len) TSRMLS_CC);
			((char *)aiTag.data)[aiTag.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiTag);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piIn_Buf);
		SBFreeArrayZValInfo(&aiNonce);
		SBSetByteArrayToZVal(&aiTag, zaTag);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, array of byte|string|NULL, &array of byte|string) or (TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUMAC, __construct)
{
	char *sKey;
	int sKey_len;
	long l4TagLen;
	SBArrayZValInfo aiKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaKey, &l4TagLen) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElUMAC_Create(aiKey.data, aiKey.len, (int32_t)l4TagLen, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sKey, &sKey_len, &l4TagLen) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUMAC_Create_1(sKey, (int32_t)sKey_len, (int32_t)l4TagLen, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer) or (string, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUMAC_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUMAC_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUMAC_Update, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, In_Buf, 0, 1)
	ZEND_ARG_INFO(0, StartIndex_or_Size)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUMAC_Final_, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Nonce, 0, 1)
	ZEND_ARG_INFO(1, Tag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUMAC_Calculate, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, In_Buf, 0, 1)
	ZEND_ARG_INFO(0, StartIndex_or_Len)
	ZEND_ARG_TYPE_INFO(0, Len_or_Nonce, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Nonce_or_Tag, 0, 1)
	ZEND_ARG_INFO(1, Tag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUMAC___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_INFO(0, TagLen)
ZEND_END_ARG_INFO()

static zend_function_entry TElUMAC_methods[] = {
	PHP_ME(TElUMAC, Clone, arginfo_TElUMAC_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElUMAC, Reset, arginfo_TElUMAC_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElUMAC, Update, arginfo_TElUMAC_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElUMAC, Final_, arginfo_TElUMAC_Final_, ZEND_ACC_PUBLIC)
	PHP_ME(TElUMAC, Calculate, arginfo_TElUMAC_Calculate, ZEND_ACC_PUBLIC)
	PHP_ME(TElUMAC, __construct, arginfo_TElUMAC___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElUMAC(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElUMAC_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElUMAC", TElUMAC_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElUMAC_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBUMAC_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBUMAC, AES_BLOCK_LEN, SB_AES_BLOCK_LEN, SB_AES_BLOCK_LEN);
	SB_REGISTER_LONG_CONSTANT(SBUMAC, UMAC_KEY_LEN, SB_UMAC_KEY_LEN, SB_UMAC_KEY_LEN);
	SB_REGISTER_LONG_CONSTANT(SBUMAC, L1_KEY_LEN, SB_L1_KEY_LEN, SB_L1_KEY_LEN);
	SB_REGISTER_LONG_CONSTANT(SBUMAC, L1_KEY_SHIFT, SB_L1_KEY_SHIFT, SB_L1_KEY_SHIFT);
	SB_REGISTER_LONG_CONSTANT(SBUMAC, L1_PAD_BOUNDARY, SB_L1_PAD_BOUNDARY, SB_L1_PAD_BOUNDARY);
	SB_REGISTER_LONG_CONSTANT(SBUMAC, HASH_BUF_BYTES, SB_HASH_BUF_BYTES, SB_HASH_BUF_BYTES);
}

