#ifndef __INC_CSGBK
#define __INC_CSGBK

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlGBKDataHandle;

#ifdef SB_USE_CLASS_TPLGBKDATA
SB_IMPORT uint32_t SB_APIENTRY TPlGBKData_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlGBKData_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlGBKData_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLGBKDATA */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlGBKData_ce_ptr;

void Register_TPlGBKData(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSGBK */

