#ifndef __INC_CSUHC
#define __INC_CSUHC

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlUHCHandle;

#ifdef SB_USE_CLASS_TPLUHC
SB_IMPORT uint32_t SB_APIENTRY TPlUHC_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlUHC_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlUHC_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLUHC */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlUHC_ce_ptr;

void Register_TPlUHC(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSUHC */

